package com.ruoyi.project.workflow.controller;

import com.ruoyi.project.workflow.common.ClsBase;
import com.ruoyi.project.workflow.common.Definition;
import com.ruoyi.project.workflow.domain.BWordbookMs;
import com.ruoyi.project.workflow.domain.db.out.BWordbookMsOut;
import com.ruoyi.project.workflow.domain.input.BWordbookSearch;
import com.ruoyi.project.workflow.domain.output.WorkFlowTableInfo;
import com.ruoyi.project.workflow.service.IBWordbookMsService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/alldict")
public class BWordbookMsController {

    @Autowired
    private IBWordbookMsService iBWordbookMsService;

    //消息
    private String outMsg;
    //消息
    private String userId;
    //language
    private String language;

    @PostMapping("/getDict")
    public WorkFlowTableInfo getDictList(@RequestBody BWordbookSearch bWordbookSearch) {
        init(bWordbookSearch.getI_language());

        WorkFlowTableInfo repData = new WorkFlowTableInfo();
        List<BWordbookMsOut> listData = new ArrayList<>();
        //字典类型
        if (StringUtils.isNotEmpty(bWordbookSearch.getI_sch_dict_type())) {
            BWordbookMs bWordbookMs = new BWordbookMs();
            //字典类型
            bWordbookMs.setiWordbookType(bWordbookSearch.getI_sch_dict_type());
            //系统区分
            bWordbookMs.setiSysFlg(bWordbookSearch.getI_sys_flg());
            //语言
            bWordbookMs.setLanguageType(language);

            //字典No
            if (Definition.ALL_DATA.equals(bWordbookSearch.getI_sch_field())) {
                listData = iBWordbookMsService.selectAllDictList(bWordbookMs);
            } else if (StringUtils.isNotEmpty(bWordbookSearch.getI_sch_field())) {
                String[] strList = bWordbookSearch.getI_sch_field().split(Definition.ROLE_DELIMETER);
                for (String str : strList) {
                    bWordbookMs.setiWordbookNo(str);
                    listData.addAll(iBWordbookMsService.selectAllDictList(bWordbookMs));
                }
            }
        }
        repData.setDataCount(String.valueOf(listData.size()));
        repData.setI_total(String.valueOf(listData.size()));
        repData.setDataList(listData);
        repData.setLogin_user(userId);
        repData.setErrorDesc(outMsg);
        repData.setResultCode(Definition.RESULT_S);

        return repData;
    }

    /**
     *初期化
     */
    private void init(String inLanguage) {
        outMsg = Definition.NULL_STR_1;
        userId = ClsBase.getCurrentUser();
        if (StringUtils.isEmpty(inLanguage)) {
            language = ClsBase.defaultLanguage();
        } else {
            language = inLanguage;
        }
    }
}
