package com.ruoyi.project.workflow.controller;

import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.project.workflow.common.ClsBase;
import com.ruoyi.project.workflow.common.Definition;
import com.ruoyi.project.workflow.domain.BAttachM;
import com.ruoyi.project.workflow.domain.WUserSettings;
import com.ruoyi.project.workflow.domain.base.InBase;
import com.ruoyi.project.workflow.domain.base.OutBase;
import com.ruoyi.project.workflow.domain.input.FileTransferDelete;
import com.ruoyi.project.workflow.domain.input.FileTransferDownLoad;
import com.ruoyi.project.workflow.domain.output.FileTransferUpOut;
import com.ruoyi.project.workflow.domain.output.WUserSettingsOut;
import com.ruoyi.project.workflow.service.BAttachMService;
import com.ruoyi.project.workflow.service.IBLanguageMsService;
import com.ruoyi.project.workflow.service.IBWordbookMsService;
import com.ruoyi.project.workflow.service.WUserSettingsService;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLEncoder;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

@RestController
@RequestMapping("/fileTransfer")
public class FileTransferController {

    private static final Logger log = LoggerFactory.getLogger(ExcelUtil.class);

    @Autowired
    private IBWordbookMsService iBWordbookMsService;
    @Autowired
    private IBLanguageMsService bLanguageMsService;
    @Autowired
    private WUserSettingsService wUserSettingsService;
    @Autowired
    private BAttachMService bAttachMService;

    //默认大小 50M
    private long DEFAULT_MAX_SIZE = 50 * 1024 * 1024;
    //默认的文件名最大长度 100
    private int DEFAULT_FILE_NAME_LENGTH = 100;

    //消息
    private String outMsg;
    //用户
    private String userId;
    //language
    private String language;

    @PostMapping("/upload")
    public FileTransferUpOut upLoad(@RequestParam("i_language") String inLanguage,
                                    @RequestParam("login_user") String loginUser,
                                    @RequestParam("i_form_id") String iFormId,
                                    @RequestParam("i_apply_id") String iApplyId,
                                    @RequestParam("applyPass") String iApplyPass,
                                    @RequestParam("file") MultipartFile upFile) {
        //初期化
        init(inLanguage);
        //表单ID
        String formId = ClsBase.getTrimData(iFormId);
        //申请ID
        String applyId = ClsBase.getTrimData(iApplyId);
        //申请通过FLG
        Boolean applyPass = false;
        if (iApplyPass != null) {
            applyPass = Boolean.valueOf(iApplyPass);
        }
        //返回
        FileTransferUpOut resData = new FileTransferUpOut();
        //处理开始
        if (upFile != null) {
            //大小
            if (upFile.getSize() > DEFAULT_MAX_SIZE) {
                outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                        Definition.MSG_COMMON_0122);
                return reFileTransferUpOut(Definition.RESULT_E);
            }
            //长度
            if (upFile.getOriginalFilename().length() > DEFAULT_FILE_NAME_LENGTH) {
                outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                        Definition.MSG_COMMON_0122);
                return reFileTransferUpOut(Definition.RESULT_E);
            }
            //文件名
            String fileName = upFile.getOriginalFilename();
            //取文件类型
            String strExtension = Definition.NULL_STR_1;
            if (fileName.contains(Definition.STR_DIAN)) {
                strExtension = fileName.substring(fileName.indexOf(Definition.STR_DIAN)).toLowerCase();
            }
            //文件类型
            String strFileType = Definition.NULL_STR_1;
            switch (strExtension) {
                case Definition.STR_PDF:
                    strFileType = Definition.STR_FILE_TYPE_P;
                    break;
                case Definition.STR_JPG:
                case Definition.STR_JPEG:
                case Definition.STR_IMG:
                case Definition.STR_PNG:
                case Definition.STR_BMP:
                case Definition.STR_GIF:
                    strFileType = Definition.STR_FILE_TYPE_TP;
                    break;
                default:
                    strFileType = Definition.NULL_STR_1;
                    break;
            }
            //新文件名
            String strFileNameNew = fileName.replace(strExtension, Definition.NULL_STR_1);
            strFileNameNew = strFileNameNew + Definition.HENG_GANG_X + ClsBase.getNowDate(Definition.DATE_FORMATE) +
                    Definition.HENG_GANG_X + userId + strExtension;
            //保存目录
            String strUploadPath = Definition.NULL_STR_1;
            //显示路径
            String strShowPath = Definition.NULL_STR_1;
            //上传文件夹
            if (StringUtils.isNotEmpty(formId) && StringUtils.isNotEmpty(applyId)) {
                //修改申请时保存至正式目录下
                strUploadPath = iBWordbookMsService.selectWordbookNameByKeys(language,
                        Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0200, Definition.FLG_Y);
                strUploadPath = makePath(strUploadPath, formId + Definition.HENG_GANG_X + applyId);
                //显示路径
                strShowPath = iBWordbookMsService.selectWordbookNameByKeys(language,
                        Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0080, Definition.FLG_Y);
                strShowPath = makePath(strShowPath, iBWordbookMsService.selectWordbookNameByKeys(language,
                        Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0201, Definition.FLG_Y));
                strShowPath = makePath(strShowPath, formId + Definition.HENG_GANG_X + applyId);
            } else {
                //新增申请时保存至临时目录下
                strUploadPath = iBWordbookMsService.selectWordbookNameByKeys(language,
                        Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0210, Definition.FLG_Y);
                //显示路径
                strShowPath = iBWordbookMsService.selectWordbookNameByKeys(language,
                        Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0080, Definition.FLG_Y);
                strShowPath = makePath(strShowPath, iBWordbookMsService.selectWordbookNameByKeys(language,
                        Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0211, Definition.FLG_Y));
            }
            //判断文件夹，并创建
            File fileUploadPath = new File(strUploadPath);
            if (!fileUploadPath.exists() || !fileUploadPath.isDirectory()) {
                if (!fileUploadPath.mkdir()) {
                    outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                            Definition.MSG_COMMON_0122);
                    return reFileTransferUpOut(Definition.RESULT_E);
                }
            }
            //文件判断
            Path fileNameNew = Paths.get(makePath(strUploadPath, strFileNameNew));
            if (fileNameNew.toFile().exists()) {
                if(!fileNameNew.toFile().delete()) {
                    outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                            Definition.MSG_COMMON_0122);
                    return reFileTransferUpOut(Definition.RESULT_E);
                }
            }
            //上传
            try {
                upFile.transferTo(fileNameNew);
            } catch (Exception e) {
                outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                        Definition.MSG_COMMON_0122);
                return reFileTransferUpOut(Definition.RESULT_E);
            }
            //审批通过时压缩申请书PDF
            if (applyPass) {
                //压缩文件
                String strZipFile = applyId + Definition.STR_ZIP;
                //文件路径
                String strZipPath = makePath(strUploadPath, Definition.STR_COMPRESS);
                File fileZipPath = new File(strZipPath);
                if (!fileZipPath.exists() || !fileZipPath.isDirectory()) {
                    if (!fileZipPath.mkdir()) {
                        outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                                Definition.MSG_COMMON_0061);
                        return reFileTransferUpOut(Definition.RESULT_E);
                    }
                }
                //移动并压缩文件
                try {
                    //移动
                    Path fileZipFile = Paths.get(makePath(strZipPath, strFileNameNew));
                    Files.move(fileNameNew, fileZipFile);
                    //压缩
                    Boolean res = ClsBase.createZipFile(strZipPath, strUploadPath, strZipFile);
                    if (!res) {
                        outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                                Definition.MSG_COMMON_0061);
                        return reFileTransferUpOut(Definition.RESULT_E);
                    }
                    if (!fileZipFile.toFile().delete() || !fileZipPath.delete()) {
                        outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                                Definition.MSG_COMMON_0061);
                        return reFileTransferUpOut(Definition.RESULT_E);
                    }
                    outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                            Definition.MSG_COMMON_0060);
                    return reFileTransferUpOut(Definition.RESULT_S);
                } catch (Exception e) {
                    log.error("上传压缩文件异常{}", e.getMessage());
                    outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                            Definition.MSG_COMMON_0061);
                    return reFileTransferUpOut(Definition.RESULT_E);
                }
            }
            //保存
            String resMsg = bAttachMService.insertNewBAttach(language, userId, strFileNameNew, fileName, strFileType);
            if (!Definition.RESULT_S.equals(resMsg)) {
                outMsg = resMsg;
                reFileTransferUpOut(Definition.RESULT_E);
            }
            resData.setI_file_name(fileName);
            resData.setI_file_name_new(strFileNameNew);
            resData.setI_file_type(strFileType);
            resData.setI_file_show(makePath(strShowPath, strFileNameNew));
        } else {
            outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0122);
            return reFileTransferUpOut(Definition.RESULT_E);
        }
        //返回
        outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0123);
        resData.setLogin_user(userId);
        resData.setErrorDesc(outMsg);
        resData.setResultCode(Definition.RESULT_S);
        return resData;
    }

    @DeleteMapping("/deleteSeal")
    public OutBase deleteSealImage(@RequestBody FileTransferDelete inData) {
        //初期化
        init(inData.getI_language());
        //从上传文件夹中删除该图片
        String strUploadPath = iBWordbookMsService.selectWordbookNameByKeys(language,
                Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0110, Definition.FLG_Y);
        //文件名
        String strFileName = ClsBase.getTrimData(inData.getFileName());
        File deleteFile = new File(strUploadPath + Definition.STR_XIEG + strFileName);
        //删除文件
        if (!deleteFile.delete()) {
            outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,  Definition.MSG_COMMON_0081);
            returnOutBase(Definition.RESULT_E);
        }
        //删除数据
        String resMsg = wUserSettingsService.deleteWUserSettingsByKeys(language, strFileName);
        if (!Definition.RESULT_S.equals(resMsg)) {
            outMsg = resMsg;
            returnOutBase(Definition.RESULT_E);
        }
        //正常返回
        outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,  Definition.MSG_COMMON_0060);
        return returnOutBase(Definition.RESULT_S);
    }

    @PostMapping("/saveSeal")
    public FileTransferUpOut saveSealImage(@RequestParam("i_language") String inLanguage,
                                           @RequestParam("avatar_file") MultipartFile file) {
        //初期化
        init(inLanguage);
        //返回
        FileTransferUpOut resData = new FileTransferUpOut();
        //文件
        if (file != null) {
            String strFileName = file.getOriginalFilename();
            //取文件类型
            String strExtension = Definition.NULL_STR_1;
            if (strFileName.contains(Definition.STR_DIAN)) {
                strExtension = strFileName.substring(strFileName.indexOf(Definition.STR_DIAN)).toLowerCase();
            }
            //文件类型
            String strFileType = Definition.NULL_STR_1;
            switch (strExtension) {
                case Definition.STR_JPG:
                case Definition.STR_JPEG:
                case Definition.STR_IMG:
                case Definition.STR_PNG:
                case Definition.STR_BMP:
                case Definition.STR_GIF:
                    strFileType = Definition.STR_FILE_TYPE_TP;
                    break;
                default:
                    strFileType = Definition.NULL_STR_1;
                    break;
            }
            //新文件名
            String strFileNameNew = Definition.STR_SEAL + userId + strExtension;
            //上传文件夹
            String strUploadPath = iBWordbookMsService.selectWordbookNameByKeys(language,
                    Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0110, Definition.FLG_Y);
            //判断文件夹，并创建
            File fileUploadPath = new File(strUploadPath);
            if (!fileUploadPath.exists() || !fileUploadPath.isDirectory()) {
                if (!fileUploadPath.mkdir()) {
                    outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                            Definition.MSG_COMMON_0122);
                    return reFileTransferUpOut(Definition.RESULT_E);
                }
            }
            //文件判断
            Path fileNameNew = Paths.get(makePath(strUploadPath, strFileNameNew));
            if (fileNameNew.toFile().exists()) {
                if (!fileNameNew.toFile().delete()) {
                    outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                            Definition.MSG_COMMON_0122);
                    return reFileTransferUpOut(Definition.RESULT_E);
                }
            }
            //上传,保存文件
            try {
                file.transferTo(fileNameNew);
            } catch (Exception e) {
                outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,
                        Definition.MSG_COMMON_0122);
                return reFileTransferUpOut(Definition.RESULT_E);
            }
            //保存
            String resMsg = wUserSettingsService.insertWUserSettings(language, strFileNameNew);
            if (!Definition.RESULT_S.equals(resMsg)) {
                outMsg = resMsg;
                reFileTransferUpOut(Definition.RESULT_E);
            }
            //返回
            resData.setI_file_name(strFileName);
            resData.setI_file_name_new(strFileNameNew);
            if (StringUtils.isEmpty(strFileType)) {
                resData.setI_file_show(Definition.NULL_STR_1);
            } else {
                //显示路径
                resData.setI_file_show(showPath(strFileNameNew));
            }
            resData.setI_file_type(strFileType);
        } else {
            outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0122);
            return reFileTransferUpOut(Definition.RESULT_E);
        }
        //返回
        resData.setResultCode(Definition.RESULT_S);
        resData.setErrorDesc(outMsg);
        resData.setLogin_user(userId);
        return resData;
    }

    @PostMapping("/downLoad")
    public void downloadFile(HttpServletResponse response, @RequestBody FileTransferDownLoad inData) {
        //初期化
        init(inData.getI_language());
        //文件名
        String fileName = ClsBase.getTrimData(inData.getI_file_name_new());
        if (StringUtils.isEmpty(fileName)) {
            outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,  Definition.MSG_COMMON_0127);
            errorResponse(response);
        }
        //表单ID
        String formId = ClsBase.getTrimData(inData.getI_form_id());
        //申请ID
        String applyId = ClsBase.getTrimData(inData.getI_apply_id());
        //目录
        String strFilePath = Definition.NULL_STR_1;
        if (StringUtils.isEmpty(formId) || StringUtils.isEmpty(applyId)) {
            //临时目录
            strFilePath = iBWordbookMsService.selectWordbookNameByKeys(language,
                    Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0210, Definition.FLG_Y);
        } else {
            //正式目录
            strFilePath = iBWordbookMsService.selectWordbookNameByKeys(language,
                    Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0200, Definition.FLG_Y);
            strFilePath = makePath(strFilePath, formId) + Definition.HENG_GANG_X + applyId;
        }
        //文件存在check
        String filePath = makePath(strFilePath ,fileName);
        File downFile = new File(filePath);
        if (!downFile.exists()) {
            outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,  Definition.MSG_COMMON_0126);
            errorResponse(response);
        }
        //文件名取得
        String strFileName = Definition.NULL_STR_1;
        BAttachM bAttachM = bAttachMService.selectBAttachMByIFileName(fileName);
        if (bAttachM != null) {
            strFileName = bAttachM.getiFileNameOrg();
        } else {
            strFileName = fileName;
        }
        //文件下载
        FileInputStream fis = null;
        OutputStream os = null;
        try {
            fis = new FileInputStream(downFile);
            int fileLength = fis.available();
            //返回
            response.setContentType("application/octet-stream");
            response.setCharacterEncoding("utf-8");
            response.addHeader("Access-Control-Expose-Headers", "Content-Disposition");
            response.addHeader("Content-Disposition","attachment;filename=" +
                    URLEncoder.encode(strFileName,"utf-8"));
            response.addHeader("Content-Length", String.valueOf(fileLength));
            //下载
            os = response.getOutputStream();
            byte[] b = new byte[fileLength];
            int length;
            while ((length = fis.read(b)) > 0) {
                os.write(b, 0, length);
            }
        } catch (Exception e) {
            log.error("下载文件异常{}", e.getMessage());
        } finally {
            try {
                if (os != null) {
                    os.close();
                }
                if (fis != null) {
                    fis.close();
                }
            } catch (Exception e) {
                log.error("下载文件异常{}", e.getMessage());
            }
        }
    }

    @PostMapping("/detail")
    public WUserSettingsOut getUserSettings(@RequestBody InBase inData) {
        //初期化
        init(inData.getI_language());
        //返回
        WUserSettingsOut resData = new WUserSettingsOut();
        //取得
        WUserSettings wUserSettings = wUserSettingsService.selectWUserSettingsByUserId(userId);
        if (wUserSettings != null) {
            resData.setI_sign_name(wUserSettings.getiSignImage());
            resData.setI_sign_image(showPath(wUserSettings.getiSignImage()));
        } else {
            resData.setI_sign_name(Definition.NULL_STR_1);
            resData.setI_sign_image(Definition.NULL_STR_1);
        }
        resData.setLogin_user(userId);
        resData.setErrorDesc(outMsg);
        resData.setResultCode(Definition.RESULT_S);
        return resData;
    }

    /**
     *初期化
     */
    private void init(String inLanguage) {
        userId = ClsBase.getCurrentUser();
        outMsg = Definition.NULL_STR_1;
        if (StringUtils.isEmpty(inLanguage)) {
            language = ClsBase.defaultLanguage();
        } else {
            language = inLanguage;
        }
    }

    /*
    返回OutBase
    */
    private OutBase returnOutBase(String resultCode) {
        OutBase rspData = new OutBase();
        rspData.setLogin_user(userId);
        rspData.setErrorDesc(outMsg);
        rspData.setResultCode(resultCode);
        return rspData;
    }

    /**
     * 返回 FileTransferUpOut
     */
    private FileTransferUpOut reFileTransferUpOut(String reCode) {
        FileTransferUpOut rspData = new FileTransferUpOut();
        rspData.setLogin_user(userId);
        rspData.setErrorDesc(outMsg);
        rspData.setResultCode(reCode);
        return rspData;
    }

    /*
     *error
     */
    private void errorResponse(HttpServletResponse response){
        OutBase rspData = new OutBase();
        rspData.setLogin_user(userId);
        rspData.setErrorDesc(outMsg);
        rspData.setResultCode(Definition.RESULT_E);
        try {
            response.setContentType("application/json");
            response.setCharacterEncoding("utf-8");
            PrintWriter pw = response.getWriter();
            pw.write(rspData.toString());
        } catch (IOException e) {
            log.error("返回异常{}", e.getMessage());
        }
    }

    /*
     * 拼接
     */
    private String makePath(String path1, String path2) {
        String resStr = Definition.NULL_STR_1;
        if (StringUtils.isNotEmpty(path1) && StringUtils.isNotEmpty(path2)) {
            resStr = path1;
            if (resStr.lastIndexOf(Definition.STR_XIEG) == resStr.length() - 1) {
                resStr = path1 + path2;
            } else {
                resStr = path1 + Definition.STR_XIEG + path2;
            }
        }
        return resStr;
    }

    /**
     * 显示路劲
     */
    private String showPath(String fileName) {
        String strShowPath = iBWordbookMsService.selectWordbookNameByKeys(language,
                Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0080, Definition.FLG_Y);
        strShowPath = makePath(strShowPath, iBWordbookMsService.selectWordbookNameByKeys(language,
                Definition.WORD_BOOK_TYPE_99_001, Definition.WORD_BOOK_NO_99_001_0111, Definition.FLG_Y));
        strShowPath = makePath(strShowPath, fileName);
        return strShowPath;
    }
}
