package com.ruoyi.project.workflow.controller;

import com.ruoyi.project.workflow.common.ClsBase;
import com.ruoyi.project.workflow.common.Definition;
import com.ruoyi.project.workflow.domain.db.out.BLanguageMsOut;
import com.ruoyi.project.workflow.domain.input.PostPartIn;
import com.ruoyi.project.workflow.domain.output.WorkFlowTableInfo;
import com.ruoyi.project.workflow.service.SysPostPartService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/postPart")
public class SysPostPartController {

    @Autowired
    private SysPostPartService sysPostPartService;

    //消息
    private String outMsg;
    //用户
    private String userId;
    //language
    private String language;

    @PostMapping("/getAllPost")
    public WorkFlowTableInfo getAllPost(@RequestBody PostPartIn inData) {
        //初期化
        init(inData.getI_language());
        //返回值
        return reOutData(sysPostPartService.getAllPost(Definition.NULL_STR_1));
    }

    @PostMapping("/getPost")
    public WorkFlowTableInfo getPost(@RequestBody PostPartIn inData) {
        //初期化
        init(inData.getI_language());
        String postId = ClsBase.getTrimData(inData.getI_sch_field());
        //返回值
        return reOutData(sysPostPartService.getAllPost(postId));
    }

    @PostMapping("/getAllRole")
    public WorkFlowTableInfo getAllRole(@RequestBody PostPartIn inData) {
        //初期化
        init(inData.getI_language());
        //返回值
        return reOutData(sysPostPartService.getAllRole(Definition.NULL_STR_1));
    }

    @PostMapping("/getRole")
    public WorkFlowTableInfo getRole(@RequestBody PostPartIn inData) {
        //初期化
        init(inData.getI_language());
        String roleId = ClsBase.getTrimData(inData.getI_sch_field());
        //返回值
        return reOutData(sysPostPartService.getAllRole(roleId));
    }

    @PostMapping("/getAllDeptPost")
    public WorkFlowTableInfo getAllDeptPost(@RequestBody PostPartIn inData) {
        //初期化
        init(inData.getI_language());
        String deptId = ClsBase.getTrimData(inData.getI_sch_field());
        //返回值
        return reOutData(sysPostPartService.getPostByDeptId(deptId));
    }

    @PostMapping("/getDeptPost")
    public WorkFlowTableInfo getDeptPost(@RequestBody PostPartIn inData) {
        //初期化
        init(inData.getI_language());
        String deptPost = ClsBase.getTrimData(inData.getI_sch_field());
        //返回值
        return reOutData(sysPostPartService.getPostByDeptId(deptPost));
    }

    /**
     *初期化
     */
    private void init(String inLanguage) {
        outMsg = Definition.NULL_STR_1;
        userId = ClsBase.getCurrentUser();
        if (StringUtils.isEmpty(inLanguage)) {
            language = ClsBase.defaultLanguage();
        } else {
            language = inLanguage;
        }
    }

    /**
     * 出力
     */
    private WorkFlowTableInfo reOutData(List<BLanguageMsOut> list) {
        //返回值
        WorkFlowTableInfo respData = new WorkFlowTableInfo();
        if (respData != null) {
            respData.setDataList(list);
            respData.setDataCount(String.valueOf(list.size()));
            respData.setI_total(String.valueOf(list.size()));
        }
        respData.setErrorDesc(outMsg);
        respData.setLogin_user(userId);
        respData.setResultCode(Definition.RESULT_S);
        return respData;
    }
}
