package com.ruoyi.project.workflow.controller;

import com.ruoyi.project.workflow.common.ClsBase;
import com.ruoyi.project.workflow.common.Definition;
import com.ruoyi.project.workflow.domain.base.InBase;
import com.ruoyi.project.workflow.domain.db.out.BLanguageMsOut;
import com.ruoyi.project.workflow.domain.db.out.UserDeptListOut;
import com.ruoyi.project.workflow.domain.input.AllDeptListIn;
import com.ruoyi.project.workflow.domain.input.DeptNameIn;
import com.ruoyi.project.workflow.domain.input.UserDeptListIn;
import com.ruoyi.project.workflow.domain.output.OutDataList;
import com.ruoyi.project.workflow.domain.output.WorkFlowTableInfo;
import com.ruoyi.project.workflow.service.SysUserDeptService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/userDept")
public class SysUserDeptController {

    @Autowired
    SysUserDeptService sysUserDeptService;

    @PostMapping("/getUserDeptList")
    public OutDataList getUserDeptList(@RequestBody UserDeptListIn userDeptListIn) {
        //返回值
        OutDataList respData = new OutDataList();
        //非空
        if (StringUtils.isNotEmpty(userDeptListIn.getI_field())) {
            respData.setDataList(sysUserDeptService.selectUserList(userDeptListIn.getI_field()));
        }
        respData.setResultCode(Definition.RESULT_S);
        //返回
        return respData;
    }

    @PostMapping("/getUserDept")
    public OutDataList getUserDept(@RequestBody UserDeptListIn userDeptListIn) {
        //返回值
        OutDataList respData = new OutDataList();
        //非空
        if (StringUtils.isNotEmpty(userDeptListIn.getI_key())) {
            List<UserDeptListOut> list = new ArrayList<>();
            for (String strKey : userDeptListIn.getI_key().split(Definition.ROLE_DELIMETER)) {
                UserDeptListOut UserDept = sysUserDeptService.getUserById(strKey);
                if (UserDept != null) {
                    list.add(UserDept);
                }
            }
            respData.setDataList(list);
        } else {
            respData.setDataList(new ArrayList<>());
        }
        respData.setResultCode(Definition.RESULT_S);
        return respData;
    }

    @PostMapping("/getAllDept")
    public OutDataList getAllDept(@RequestBody AllDeptListIn allDeptListIn) {
        //返回值
        OutDataList respData = new OutDataList();
        respData.setDataList(sysUserDeptService.getDeptTreeWork());
        respData.setResultCode(Definition.RESULT_S);
        return respData;
    }

    @PostMapping("/getDeptName")
    public WorkFlowTableInfo getDeptName(@RequestBody DeptNameIn deptNameIn) {
        //返回值
        WorkFlowTableInfo respData = new WorkFlowTableInfo();
        List<BLanguageMsOut> outData = sysUserDeptService.selectDeptNamesByDeptIds(
                ClsBase.getTrimData(deptNameIn.getI_sch_field()));
        if (outData != null) {
            respData.setDataCount(String.valueOf(outData.size()));
            respData.setI_total(String.valueOf(outData.size()));
            respData.setDataList(outData);
        }
        respData.setLogin_user(ClsBase.getCurrentUser());
        respData.setResultCode(Definition.RESULT_S);
        return respData;
    }

    @PostMapping("/getAllCompany")
    public WorkFlowTableInfo getAllCompany(@RequestBody InBase deptNameIn) {
        //返回值
        WorkFlowTableInfo respData = new WorkFlowTableInfo();
        List<BLanguageMsOut> outData = sysUserDeptService.selectDeptNamesByParentId(100L);
        if (outData != null) {
            respData.setDataCount(String.valueOf(outData.size()));
            respData.setI_total(String.valueOf(outData.size()));
            respData.setDataList(outData);
        }
        respData.setLogin_user(ClsBase.getCurrentUser());
        respData.setResultCode(Definition.RESULT_S);
        return respData;
    }
}
