package com.ruoyi.project.workflow.controller;

import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.framework.aspectj.lang.annotation.Log;
import com.ruoyi.framework.aspectj.lang.enums.BusinessType;
import com.ruoyi.project.workflow.common.ClsBase;
import com.ruoyi.project.workflow.common.Definition;
import com.ruoyi.project.workflow.common.ExcelBase;
import com.ruoyi.project.workflow.domain.WApplication;
import com.ruoyi.project.workflow.domain.WFormLayout;
import com.ruoyi.project.workflow.domain.base.InBase;
import com.ruoyi.project.workflow.domain.base.OutBase;
import com.ruoyi.project.workflow.domain.base.OutButtonBase;
import com.ruoyi.project.workflow.domain.db.in.WFormDesignMyAppLyIn;
import com.ruoyi.project.workflow.domain.db.out.FormInfoOut;
import com.ruoyi.project.workflow.domain.db.out.WFormDesignMyApplyOut;
import com.ruoyi.project.workflow.domain.input.*;
import com.ruoyi.project.workflow.domain.output.MapData;
import com.ruoyi.project.workflow.domain.output.WorkFlowTableInfo;
import com.ruoyi.project.workflow.service.*;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/myApply")
public class WFormDesignMyApplyController {

    private static final Logger log = LoggerFactory.getLogger(ExcelUtil.class);

    @Autowired
    private IBLanguageMsService bLanguageMsService;
    @Autowired
    private IBWordbookMsService iBWordbookMsService;
    @Autowired
    private WFormDesignMyApplyService wFormDesignMyAppLyService;
    @Autowired
    private IBFunctionMsService iBFunctionMsService;
    @Autowired
    private WApplicationService wApplicationService;
    @Autowired
    private WReferenceUserService wReferenceUserService;
    @Autowired
    private WFormLayoutService wFormLayoutService;
    @Autowired
    private BAttachMService bAttachMService;
    @Autowired
    private WFlowTaskService wFlowTaskService;
    @Autowired
    private SendMailService sendMailService;
    @Autowired
    private WFormDesignService wFormDesignService;
    @Autowired
    private WFormDataService wFormDataService;

    //消息
    private String outMsg;
    //用户
    private String userId;
    //language
    private String language;

    @PostMapping("/init")
    public MapData getInit(@RequestBody InBase inData) {
        //初期化
        init(inData.getI_language());
        //返回
        MapData resData = new MapData();
        //按钮名
        OutButtonBase outButtonBase = iBWordbookMsService.selectButtonInfo(language);
        outButtonBase.setI_btn_import(Definition.NULL_STR_1);
        outButtonBase.setI_btn_delete(Definition.NULL_STR_1);
        outButtonBase.setI_btn_add(Definition.NULL_STR_1);
        resData.getData().put(Definition.STR_BUTTON, outButtonBase);
        //每页显示条数
        resData.getData().put(Definition.STR_I_PERPAGE, iBWordbookMsService.selectPerPage(language));
        //得分页条数
        resData.getData().put(Definition.STR_PERPAGELIST, iBWordbookMsService.selectDataList(language,
                Definition.WORD_BOOK_TYPE_99_006, Definition.FLG_Y));
        //状态
        resData.getData().put(Definition.STR_APPLYSTATUSLIST,
                iBWordbookMsService.selectWorkBookInfoByType(language, Definition.WORD_BOOK_TYPE_40_002,
                        Definition.WORD_BOOK_NO_NOT_2_4, Definition.FLG_Y));
        resData.setLogin_user(userId);
        resData.setResultCode(Definition.RESULT_S);
        return resData;
    }

    @PostMapping("/getList")
    public WorkFlowTableInfo getList(@RequestBody WFormDesignMyAppLy inData) {
        //初期化
        init(inData.getI_language());
        //检索条件
        WFormDesignMyAppLyIn selectIn = editSearch(inData);
        //总页数
        Long nTotal = wFormDesignMyAppLyService.selectMyApplyCount(selectIn);
        //取得分页数据
        if (inData.getI_pageindex() == 1) {
            selectIn.setOffSet(Long.valueOf(0));
            if (nTotal > inData.getI_perpage()) {
                selectIn.setNum(inData.getI_perpage());
            } else {
                selectIn.setNum(nTotal);
            }
        } else {
            selectIn.setOffSet(inData.getI_perpage() * (inData.getI_pageindex() - 1));
            if ((nTotal - selectIn.getOffSet()) > inData.getI_perpage()) {
                selectIn.setNum(inData.getI_perpage());
            } else {
                selectIn.setNum(nTotal - selectIn.getOffSet());
                if (selectIn.getNum() < 0) {
                    selectIn.setNum(Long.valueOf(0));
                }
            }
        }
        List<WFormDesignMyApplyOut> list = wFormDesignMyAppLyService.selectMyApplyList(selectIn);
        //返回数据
        WorkFlowTableInfo respData = new WorkFlowTableInfo();
        respData.setLogin_user(userId);
        if (list != null) {
            respData.setDataCount(String.valueOf(list.size()));
            respData.setDataList(list);
            //表单状态
            if (list.size() > 0) {
                for (WFormDesignMyApplyOut myAppLyOut : list) {
                    myAppLyOut.setI_form_status(wFormDesignService.getFormStatusByFormId(
                            String.valueOf(myAppLyOut.getI_form_id())));
                }
            }
        }
        respData.setI_total(String.valueOf(nTotal));
        respData.setResultCode(Definition.RESULT_S);

        return respData;
    }

    @PostMapping("/export")
    @Log(title = Definition.PAGE_401020, businessType = BusinessType.EXPORT)
    public void export(HttpServletResponse response, @RequestBody WFormDesignMyAppLy inData) {
        //初期化
        init(inData.getI_language());
        //检索条件
        WFormDesignMyAppLyIn selectIn = editSearch(inData);
        //取得数据
        List<WFormDesignMyApplyOut> list = wFormDesignMyAppLyService.selectMyApplyUnLimt(selectIn);
        //表单状态
        if (list != null && list.size() > 0) {
            for (WFormDesignMyApplyOut myAppLyOut : list) {
                myAppLyOut.setI_form_status(wFormDesignService.getFormStatusByFormId(
                        String.valueOf(myAppLyOut.getI_form_id())));
            }
        }
        //gridInfo
        if (inData.getTable_info() == null) {
            outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,  Definition.MSG_COMMON_0100);
            errorResponse(response);
        }
        //取得页面名称
        String strDownloadFileName = iBFunctionMsService.GetFuncName(language, Definition.PAGE_401020);
        //excel名
        String excelName = ClsBase.getEccelName(strDownloadFileName, userId);
        //导出
        ExcelBase<WFormDesignMyApplyOut> util = new ExcelBase<>(WFormDesignMyApplyOut.class);
        util.exportExcel(response, inData.getTable_info(), list, Definition.EXPORT_INFO, excelName);
    }

    @PostMapping("/detail")
    public MapData getDetail(@RequestBody WFormDesignMyAppLyDetail inData) {
        //初期化
        init(inData.getI_language());
        //申请编号
        String applyId = ClsBase.getTrimData(inData.getI_apply_no());
        if (StringUtils.isEmpty(applyId)) {
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020,  Definition.MSG_401020_0001);
            return errorMapData();
        }
        if (applyId.getBytes().length > 16) {
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020,  Definition.MSG_401020_0002);
            return errorMapData();
        }
        //是否为拷贝申请书详情
        Boolean isCopy = false;
        if (inData.getI_is_copy() != null) {
            isCopy = inData.getI_is_copy();
        }
        //取得最大申请回数（最新状态）
        Long submitTimes = wApplicationService.selectApplyMaxTimes(applyId);
        if (submitTimes == null || submitTimes == 0) {
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020,  Definition.MSG_401020_0004);
            return errorMapData();
        }
        //取得最新申请详细
        WApplication wApplication = wApplicationService.selectApplyInfoByApplyIds(applyId, submitTimes);
        if (wApplication == null) {
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020,  Definition.MSG_401020_0004);
            return errorMapData();
        }
        //取得阅览人详细
        List<String> referenceUsers = wReferenceUserService.selectReferenceUser(applyId);
        String noticeReaders = Definition.NULL_STR_1;
        if (referenceUsers != null && referenceUsers.size() > 0) {
            for (int i = 0; i < referenceUsers.size(); i++) {
                if (i == 0) {
                    noticeReaders = referenceUsers.get(i);
                } else {
                    noticeReaders = noticeReaders + Definition.ROLE_DELIMETER + referenceUsers.get(i);
                }
            }
        }
        //Form Id
        String strFormId = String.valueOf(wApplication.getiFormId());
        //取得申请数据
        Map<String, Object> dtHash = wFormDesignMyAppLyService.selectFormDataByApplyId(applyId, submitTimes);
        //返回值追加
        dtHash.put(Definition.STR_I_STATUS, wApplication.getiStatus());
        dtHash.put(Definition.STR_I_NOTICE_READERS, noticeReaders);
        dtHash.put(Definition.STR_I_APPLY_USER, wApplication.getiApplUser());
        dtHash.put(Definition.STR_FORMID, strFormId);
        //拷贝申请书的场合，需要把申请书拷贝到临时文件夹下
        if (isCopy) {
            //获取表单结构
            List<WFormLayout>  listLayout = wFormLayoutService.selectStructureByFormId(strFormId);
            //遍历数据表的列
            if (listLayout != null && listLayout.size() > 0) {
                for (WFormLayout item : listLayout) {
                    String strCol = item.getiFormDataCol();
                    if (strCol.startsWith(Definition.UPLOAD)) {
                        //列名对应的键值对存在的场合
                        if (dtHash.containsKey(strCol)) {
                            //将申请书的文件拷贝一份到临时文件夹
                            String fileNames = dtHash.get(strCol).toString();
                            String newFileNames = copyFileAndMove(strFormId, applyId, fileNames);
                            if (StringUtils.isNotEmpty(outMsg)) {
                                return errorMapData();
                            }
                            dtHash.put(strCol, newFileNames);
                        }
                    }
                }
            }
        }
        MapData rspData = new MapData();
        rspData.getData().put(Definition.STR_DATA, dtHash);
        rspData.getData().put(Definition.STR_FLOW, wFlowTaskService.getFlowTaskByApplyId(language, applyId));
        rspData.setLogin_user(userId);
        rspData.setResultCode(Definition.RESULT_S);
        return rspData;
    }

    @PostMapping("/save")
    @Log(title = Definition.PAGE_401020, businessType = BusinessType.INSERT)
    public OutBase saveApply(@RequestBody Map<String, Object> inMapData) {
        //入力变换
        WFormDesignMyAppLySave inData = toBean(inMapData);
        //初期化
        init(inData.getI_language());
        //申请Id
        String applyId = ClsBase.getTrimData(inData.getI_apply_id());
        if (StringUtils.isEmpty(applyId)) {
            //[申请编号]不能为空
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0001);
            return returnOutBase(Definition.RESULT_E);
        }
        //提交操作
        if (inData.getSubmit() == null) {
            //[申请操作]不能为空
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020,  Definition.MSG_401020_0003);
            return returnOutBase(Definition.RESULT_E);
        }
        //CC者
        String strReferenceUser = ClsBase.getTrimData(inData.getI_notice_readers());
        //根据申请编号取得最新版本（最大提交回数）
        Long applyTimes =  wApplicationService.selectApplyMaxTimes(applyId);
        //申请ID关联情报取得
        FormInfoOut formInfoOut = wApplicationService.selectFormInfoByApplyId(applyId, applyTimes);
        if (formInfoOut == null) {
            //申请编号对应的申请管理不存在
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0004);
            return returnOutBase(Definition.RESULT_E);
        }
        //审批要否为要的场合，取得流程结构
        String strFlowData = Definition.NULL_STR_1;
        if (Definition.STR_TRUE.equals(formInfoOut.getiFlowFlg())) {
            strFlowData = formInfoOut.getiFlowData();
        }
        //表单状态取得
        String strStatus = wFormDesignService.getFormStatusByFormId(formInfoOut.getiFormId());
        //表单状态判定（申请书状态为否决时，不做表单过期的check）
        if (StringUtils.isNotEmpty(strStatus) &&
                !Definition.STR_REJECT.equals(formInfoOut.getiStatus())) {
            if (Definition.CLOSED.equals(strStatus)) {
                //过期的场合
                if (inData.getSubmit()) {
                    outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0026);
                    return returnOutBase(Definition.RESULT_E);
                } else {
                    outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0025);
                    return returnOutBase(Definition.RESULT_E);
                }
            }
        }
        //通过表单Id获取申请数据表结构
        List<WFormLayout> listWFormLayout = wFormLayoutService.selectStructureByFormId(formInfoOut.getiFormId());
        if (listWFormLayout == null || listWFormLayout.size() == 0) {
            //申请编号对应的申请数据不存在
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0005);
            return returnOutBase(Definition.RESULT_E);
        } else {
            if (StringUtils.isEmpty(listWFormLayout.get(0).getiFormDataTblname())) {
                //[申请数据表]不存在
                outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0006);
                return returnOutBase(Definition.RESULT_E);
            }
        }
        //文件
        List<String> uploadFiles = new ArrayList<>();
        List<String> uploadCols = new ArrayList<>();
        //遍历数据表的列
        for (WFormLayout item : listWFormLayout) {
            String strCol = ClsBase.getTrimData(item.getiFormDataCol());
            if (StringUtils.isNotEmpty(strCol)) {
                String strVal = Definition.NULL_STR_1;
                //控件为upload的场合
                if (item.getiFormDataControl().startsWith(Definition.UPLOAD)) {
                    if (inData.getParams().get(strCol) != null) {
                        strVal = inData.getParams().get(strCol).toString();
                        Collections.addAll(uploadFiles, strVal.split(Definition.RADICAL_LINE));
                        uploadCols.add(strCol);
                    }
                }
            }
        }
        //判断当前申请书状态（一时保存的场合：更新，以外的场合：新增）
        String strApplyId = Definition.NULL_STR_1;
        String strPreApplyId = Definition.NULL_STR_1;
        Long submitTimes = 0L;
        if (Definition.STR_INACTIVE.equals(formInfoOut.getiStatus())) {
            //一时保存的场合
            strApplyId = applyId;
            submitTimes = applyTimes;
        } else if (Definition.STR_PASS.equals(formInfoOut.getiStatus())) {
            //审批通过的场合
            strPreApplyId = applyId;
            //申请ID采番
            strApplyId = wApplicationService.getApplyId(formInfoOut.getiNumberRules());
            submitTimes = Definition.FST_VERSION;
        } else if (Definition.STR_REJECT.equals(formInfoOut.getiStatus())) {
            //审批否决的场合
            strApplyId = applyId;
            submitTimes = applyTimes + 1L;
        } else {
            //操作异常
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0007);
            return returnOutBase(Definition.RESULT_E);
        }
        //创建申请书文件夹，并Merge上传的文件
        mergeFile(formInfoOut.getiFormId(), strApplyId, listWFormLayout.get(0).getiFormDataTblname(),
                uploadFiles, uploadCols);
        if (StringUtils.isNotEmpty(outMsg)) {
            return returnOutBase(Definition.RESULT_E);
        }
        //数据保存
        String resMsg = wFormDesignMyAppLyService.updateDatas(language, listWFormLayout, inData.getParams(),
                listWFormLayout.get(0).getiFormDataTblname(), strApplyId, strPreApplyId, submitTimes,
                formInfoOut.getiFormId(), formInfoOut.getiStatus(), strReferenceUser);
        if (!Definition.RESULT_S.equals(resMsg)) {
            outMsg = resMsg;
            return returnOutBase(Definition.RESULT_E);
        }
        //提交的场合，生成流转流程
        if (inData.getSubmit()) {
            //生成流转流程
            resMsg = wFlowTaskService.generateTasks(language, formInfoOut.getiFormId(), strApplyId,
                    submitTimes, strFlowData, inData.getParams());
            if (!Definition.RESULT_S.equals(resMsg)) {
                outMsg = resMsg;
                return returnOutBase(Definition.RESULT_E);
            }
            //发送审批请求邮件
            resMsg = sendMailService.aduitApplyMail(language, strApplyId, submitTimes, strReferenceUser);
            if (!Definition.RESULT_S.equals(resMsg)) {
                outMsg = resMsg;
                return returnOutBase(Definition.RESULT_E);
            }
            //提交成功
            outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0120);
            return returnOutBase(Definition.RESULT_S);
        } else {
            //保存成功
            outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0090);
            return returnOutBase(Definition.RESULT_S);
        }
    }


    @DeleteMapping("/delete")
    @Log(title = Definition.PAGE_401020, businessType = BusinessType.DELETE)
    public OutBase deleteApply(@RequestBody WFormDesignMyAppLyUpdate inData) {
        //初期化
        init(inData.getI_language());
        //申请Id
        String applyId = ClsBase.getTrimData(inData.getI_apply_id());
        if (StringUtils.isEmpty(applyId)) {
            //[申请编号]不能为空
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0001);
            return returnOutBase(Definition.RESULT_E);
        }
        //删除申请
        String resMsg = wFormDesignMyAppLyService.deleteApplyByApplyId(language, applyId);
        if (!Definition.RESULT_S.equals(resMsg)) {
            outMsg = resMsg;
            return returnOutBase(Definition.RESULT_E);
        }
        //删除成功
        outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0080);
        return returnOutBase(Definition.RESULT_S);
    }

    @PostMapping("/cancel")
    @Log(title = Definition.PAGE_401020, businessType = BusinessType.UPDATE)
    public OutBase cancelApply(@RequestBody WFormDesignMyAppLyUpdate inData) {
        //初期化
        init(inData.getI_language());
        //申请Id
        String applyId = ClsBase.getTrimData(inData.getI_apply_id());
        if (StringUtils.isEmpty(applyId)) {
            //[申请编号]不能为空
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0001);
            return returnOutBase(Definition.RESULT_E);
        }
        //申请回数
        Long applyTimes = wApplicationService.selectApplyMaxTimes(applyId);
        //取消申请
        String resMsg = wFormDesignMyAppLyService.cancelApplyByApplyId(language, applyId, applyTimes);
        if (!Definition.RESULT_S.equals(resMsg)) {
            outMsg = resMsg;
            return returnOutBase(Definition.RESULT_E);
        }
        //取消申请后，需要给之前承认过的人及阅览者发送邮件
        resMsg = sendMailService.cancelApplyMail(language, applyId, applyTimes);
        if (!Definition.RESULT_S.equals(resMsg)) {
            outMsg = resMsg;
            return returnOutBase(Definition.RESULT_E);
        }
        //取消成功
        outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0130);
        return returnOutBase(Definition.RESULT_S);
    }

    @PostMapping("/noticeReference")
    public OutBase noticeReferenceUser(@RequestBody WFormDesignMyAppLyNotice inData) {
        //初期化
        init(inData.getI_language());
        //申请Id
        String applyId = ClsBase.getTrimData(inData.getI_apply_id());
        if (StringUtils.isEmpty(applyId)) {
            //[申请编号]不能为空
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0001);
            return returnOutBase(Definition.RESULT_E);
        }
        //需要通知的人
        String noticeReaders = ClsBase.getTrimData(inData.getI_notice_readers());
        if (StringUtils.isEmpty(noticeReaders)) {
            //[阅览者]不能为空
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0011);
            return returnOutBase(Definition.RESULT_E);
        }
        //追加阅览者到DB
        String resMsg = wFormDesignMyAppLyService.addReferenceUsers(language, applyId, noticeReaders);
        if (!Definition.RESULT_S.equals(resMsg)) {
            outMsg = resMsg;
            return returnOutBase(Definition.RESULT_E);
        }
        //给选定的阅览者发送邮件
        resMsg = sendMailService.noticeMail(language, applyId, noticeReaders);
        if (!Definition.RESULT_S.equals(resMsg)) {
            outMsg = resMsg;
            return returnOutBase(Definition.RESULT_E);
        }
        //通知成功
        outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0210);
        return returnOutBase(Definition.RESULT_S);
    }

    @PostMapping("/pushMessage")
    public OutBase pushMessageToAduit(@RequestBody WFormDesignMyAppLyPush inData) {
        //初期化
        init(inData.getI_language());
        //申请Id
        String applyId = ClsBase.getTrimData(inData.getI_apply_id());
        if (StringUtils.isEmpty(applyId)) {
            //[申请编号]不能为空
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0001);
            return returnOutBase(Definition.RESULT_E);
        }
        //推送对象
        String contactUser = ClsBase.getTrimData(inData.getI_contact_user());
        if (StringUtils.isEmpty(contactUser)) {
            //[推送者]不能为空
            outMsg = bLanguageMsService.GetMessage(language, Definition.PAGE_401020, Definition.MSG_401020_0027);
            return returnOutBase(Definition.RESULT_E);
        }
        //推送消息
        String pushMsg = ClsBase.getTrimData(inData.getI_comment());
        //推送文件
        String pushFile = ClsBase.getTrimData(inData.getI_files());
        //给选定的阅览者发送邮件
        String resMsg = sendMailService.pushMail(language, applyId, contactUser, pushMsg, pushFile);
        if (!Definition.RESULT_S.equals(resMsg)) {
            outMsg = resMsg;
            return returnOutBase(Definition.RESULT_E);
        } else {
            outMsg = bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0060);
            return  returnOutBase(Definition.RESULT_S);
        }
    }

    /*
   返回OutBase
    */
    private OutBase returnOutBase(String resultCode) {
        OutBase rspData = new OutBase();
        rspData.setLogin_user(userId);
        rspData.setErrorDesc(outMsg);
        rspData.setResultCode(resultCode);
        return rspData;
    }

    /*
    更新文件夹中的文件：对于已被删除的添付文件进行删除处理
     */
    private void mergeFile(String formId, String applyId, String tblName, List<String> fileNames,
                           List<String> uploadCols) {
        //格纳文件夹
        String strSavePath = iBWordbookMsService.selectWordbookNameByKeys(language, Definition.WORD_BOOK_TYPE_99_001,
                Definition.WORD_BOOK_NO_99_001_0200, Definition.FLG_Y);
        //判断格纳文件夹，不存在的场合，创建
        File fileSavePath = new File(strSavePath);
        if (!fileSavePath.exists() || !fileSavePath.isDirectory()) {
            fileSavePath.mkdir();
        }
        //判断格纳文件夹，不存在的场合，创建
        String strSavePathzi = strSavePath + Definition.STR_XIEG + formId + Definition.HENG_GANG_X + applyId;
        File fileSavePathzi = new File(strSavePathzi);
        if (!fileSavePathzi.exists() || !fileSavePathzi.isDirectory()) {
            fileSavePathzi.mkdir();
        }
        //不存在上传控件
        if (uploadCols == null || uploadCols.size() == 0) {
            return;
        }
        //获取前回保存文件
        List<String> oldUploadFiles = new ArrayList<>();
        Map<String, Object> mapData = wFormDataService.selectFormDataByApplyId(tblName, applyId);
        if (mapData != null) {
            for (String strKey : mapData.keySet()) {
                if (uploadCols.contains(strKey)) {
                    if (mapData.get(strKey) != null) {
                        Collections.addAll(oldUploadFiles,
                                mapData.get(strKey).toString().split(Definition.RADICAL_LINE));
                    }
                }
            }
        }
        //去除存在的文件
        for (String fileName : fileNames) {
            oldUploadFiles.remove(fileName);
        }
        //删除不存在的文件
        String delAttachSql = Definition.NULL_STR_1;
        for (int i = 0; i < oldUploadFiles.size(); i++) {
            if (StringUtils.isNotEmpty(oldUploadFiles.get(i))) {
                String strDestFile = strSavePathzi + Definition.STR_XIEG + oldUploadFiles.get(i);
                File fileDestFile = new File(strDestFile);
                if (fileDestFile.exists()) {
                    fileDestFile.delete();
                }
                if (i > 0) {
                    delAttachSql = delAttachSql + Definition.ROLE_DELIMETER;
                }
                delAttachSql = delAttachSql + oldUploadFiles.get(i);
            }
        }
        //删除数据
        String resMsg = wFormDesignMyAppLyService.deleteAttach(language, delAttachSql);
        if (!Definition.RESULT_S.equals(resMsg)) {
            outMsg = resMsg;
        }
    }
    /*
    将申请书的文件拷贝一份到临时文件夹
     */
    private String copyFileAndMove(String formId, String applyId, String oldFileNames) {
        //新文件名
        String newFileNames = Definition.NULL_STR_1;
        //格纳文件夹
        String strSavePath = iBWordbookMsService.selectWordbookNameByKeys(language, Definition.WORD_BOOK_TYPE_99_001,
                Definition.WORD_BOOK_NO_99_001_0200, Definition.FLG_Y);
        //临时文件夹
        String strTempPath = iBWordbookMsService.selectWordbookNameByKeys(language, Definition.WORD_BOOK_TYPE_99_001,
                Definition.WORD_BOOK_NO_99_001_0210, Definition.FLG_Y);
        //判断格纳文件夹，不存在的场合退出
        File fileSavePath = new File(strSavePath);
        if (!fileSavePath.exists() || !fileSavePath.isDirectory()) {
            return Definition.NULL_STR_1;
        }
        //判断格纳文件夹
        String strSavePathzi = strSavePath + Definition.STR_XIEG + formId + Definition.HENG_GANG_X + applyId;
        File fileSavePathzi = new File(strSavePathzi);
        if (!fileSavePathzi.exists() || !fileSavePathzi.isDirectory()) {
            return Definition.NULL_STR_1;
        }
        //判断临时文件夹，不存在的场合，创建
        File fileTempPath = new File(strTempPath);
        if (!fileTempPath.exists() || !fileTempPath.isDirectory()) {
            fileTempPath.mkdir();
        }
        //文件迁移
        for (String oldFileName : oldFileNames.split(Definition.RADICAL_LINE)) {
            if (StringUtils.isNotEmpty(oldFileName)) {
                //格纳文
                Path strSourceFile = Paths.get(strSavePathzi + Definition.STR_XIEG + oldFileName);
                //文件名
                String fileName = oldFileName;
                //取文件类型
                String strExtension = Definition.NULL_STR_1;
                if (oldFileName.contains(Definition.STR_DIAN)) {
                    strExtension = fileName.substring(oldFileName.indexOf(Definition.STR_DIAN)).toLowerCase();
                }
                //去除"_"：xxxxx_yyMMddhhmmss_userid.ext → xxxxx_yyMMddhhmmss → xxxxx
                int loopTimes = 0;
                while (fileName.contains(Definition.HENG_GANG_X) && loopTimes < 2) {
                    fileName = fileName.substring(0, fileName.lastIndexOf(Definition.HENG_GANG_X));
                    loopTimes++;
                }
                //新文件名
                fileName = fileName.replace(strExtension, Definition.NULL_STR_1) +
                        Definition.HENG_GANG_X + ClsBase.getNowDate(Definition.DATE_FORMATE) +
                        Definition.HENG_GANG_X + userId + strExtension;
                //新文件名的全路径
                Path strDestFile = Paths.get(strTempPath + Definition.STR_XIEG + fileName);
                //拼成新的文件字符串
                if (StringUtils.isEmpty(newFileNames)) {
                    newFileNames = fileName;
                } else {
                    newFileNames = newFileNames + Definition.RADICAL_LINE2 + fileName;
                }
                //临时文件夹中，判断文件是否存在，存在的场合，删除
                if (strDestFile.toFile().exists()) {
                    strDestFile.toFile().delete();
                }
                //格纳文件夹中，判断文件是否存在，存在的场合，拷贝
                if (strSourceFile.toFile().exists()) {
                    try {
                        Files.copy(strSourceFile, strDestFile);
                    } catch (Exception e) {
                        outMsg = e.getMessage();
                        return Definition.NULL_STR_1;

                    }
                }
                String outStr = bAttachMService.insertBAttachMNewOldFileName(language, userId,
                        oldFileName, fileName);
                if (!Definition.RESULT_S.equals(outStr)) {
                    outMsg = outStr;
                    return Definition.NULL_STR_1;
                }
            }
        }
        return newFileNames;
    }

    /*
    返回error MapData
     */
    private MapData errorMapData() {
        MapData rspData = new MapData();
        rspData.setLogin_user(userId);
        rspData.setErrorDesc(outMsg);
        rspData.setResultCode(Definition.RESULT_E);
        return rspData;
    }

    /*
     *error
     */
    private void errorResponse(HttpServletResponse response){
        OutBase rspData = new OutBase();
        rspData.setLogin_user(userId);
        rspData.setErrorDesc(outMsg);
        rspData.setResultCode(Definition.RESULT_E);
        try {
            response.setContentType("application/json");
            response.setCharacterEncoding("utf-8");
            PrintWriter pw = response.getWriter();
            pw.write(rspData.toString());
        } catch (IOException e) {
            log.error("返回异常{}", e.getMessage());
        }
    }

    /*
    检索条件
     */
    private WFormDesignMyAppLyIn editSearch(WFormDesignMyAppLy inData) {
        WFormDesignMyAppLyIn wFormDesignMyAppLyIn = new WFormDesignMyAppLyIn();
        wFormDesignMyAppLyIn.setLanguageType(language);
        wFormDesignMyAppLyIn.setUserId(userId);
        wFormDesignMyAppLyIn.setiSchField(ClsBase.getTrimData(inData.getI_sch_field()));
        wFormDesignMyAppLyIn.setiSchApplyStatu(ClsBase.getTrimData(inData.getI_sch_apply_status()));
        return  wFormDesignMyAppLyIn;
    }

    /**
     *初期化
     */
    private void init(String inLanguage) {
        userId = ClsBase.getCurrentUser();
        outMsg = Definition.NULL_STR_1;
        if (StringUtils.isEmpty(inLanguage)) {
            language = ClsBase.defaultLanguage();
        } else {
            language = inLanguage;
        }
    }

    /**
     * 入力变换
     */
    private WFormDesignMyAppLySave toBean(Map<String, Object> map) {
        WFormDesignMyAppLySave resBean = new WFormDesignMyAppLySave();
        if (map != null) {
            for (String inKey : map.keySet()) {
                switch (inKey) {
                    case Definition.STR_FORMID:
                        resBean.setFormId(String.valueOf(map.get(inKey)));
                        break;
                    case Definition.I_APPLY_ID:
                        resBean.setI_apply_id(String.valueOf(map.get(inKey)));
                        break;
                    case Definition.STR_I_APPLY_USER:
                        resBean.setI_apply_user(String.valueOf(map.get(inKey)));
                        break;
                    case Definition.STR_I_STATUS:
                        resBean.setI_status(String.valueOf(map.get(inKey)));
                        break;
                    case Definition.STR_IS_SUBMIT:
                        if (map.get(inKey) != null) {
                            resBean.setSubmit(Boolean.valueOf(map.get(inKey).toString()));
                        }
                        break;
                    case Definition.STR_I_NOTICE_READERS:
                        resBean.setI_notice_readers(String.valueOf(map.get(inKey)));
                        break;
                    case Definition.STR_LOGIN_USER:
                        resBean.setLogin_user(String.valueOf(map.get(inKey)));
                        break;
                    case Definition.I_LANGUAGE:
                        resBean.setI_language(String.valueOf(map.get(inKey)));
                        break;
                    default:
                        resBean.getParams().put(inKey, map.get(inKey));
                        break;
                }
            }
        }
        return resBean;
    }
}
