package com.ruoyi.project.workflow.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.framework.aspectj.lang.annotation.Excel;
import com.ruoyi.framework.web.domain.BaseEntity;

import java.util.Date;

/**
 * 功能菜单对象 b_function_ms
 *
 * @author ruoyi
 * @date 2023-05-23
 */
public class BFunctionMs extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 功能ID */
    private String iFuncId;

    /** 功能名称_中文 */
    @Excel(name = "功能名称_中文")
    private String iFuncNameCh;

    /** 功能名称_日文 */
    @Excel(name = "功能名称_日文")
    private String iFuncNameJp;

    /** 功能名称_英文 */
    @Excel(name = "功能名称_英文")
    private String iFuncNameEn;

    /** 功能路径 */
    @Excel(name = "功能路径")
    private String iFuncPath;

    /** 功能顺序 */
    @Excel(name = "功能顺序")
    private String iFuncSort;

    /** 有效标志（Y：有效，N：无效） */
    @Excel(name = "有效标志", readConverterExp = "Y=：有效，N：无效")
    private String iEnableFlag;

    /** 新增标志 */
    @Excel(name = "新增标志")
    private String iAddFlag;

    /** 更新标志 */
    @Excel(name = "更新标志")
    private String iUpdateFlag;

    /** 删除标志 */
    @Excel(name = "删除标志")
    private String iDeleteFlag;

    /** 导出标志 */
    @Excel(name = "导出标志")
    private String iExportFlag;

    /** 导入标志 */
    @Excel(name = "导入标志")
    private String iImportFlag;

    /** 特殊权限 */
    @Excel(name = "特殊权限")
    private String iSpecialFlag;

    /** 应用ID */
    @Excel(name = "应用ID")
    private String iAppId;

    /** 应用顺序 */
    @Excel(name = "应用顺序")
    private String iAppSort;

    /** 应用名称_中文 */
    @Excel(name = "应用名称_中文")
    private String iAppNameCh;

    /** 应用名称_日文 */
    @Excel(name = "应用名称_日文")
    private String iAppNameJp;

    /** 应用名称_英文 */
    @Excel(name = "应用名称_英文")
    private String iAppNameEn;

    /** 应用Icon */
    @Excel(name = "应用Icon")
    private String iAppIcon;

    /** 应用路径 */
    @Excel(name = "应用路径")
    private String iAppPath;

    /** 模块ID */
    @Excel(name = "模块ID")
    private String iModuleId;

    /** 模块顺序 */
    @Excel(name = "模块顺序")
    private String iModuleSort;

    /** 模块名称_中文 */
    @Excel(name = "模块名称_中文")
    private String iModuleNameCh;

    /** 模块名称_日文 */
    @Excel(name = "模块名称_日文")
    private String iModuleNameJp;

    /** 模块名称_英文 */
    @Excel(name = "模块名称_英文")
    private String iModuleNameEn;

    /** 模块Icon */
    @Excel(name = "模块Icon")
    private String iModuleIcon;

    /** 模块路径 */
    @Excel(name = "模块路径")
    private String iModulePath;

    /** 功能路径（工程文件) */
    @Excel(name = "功能路径", readConverterExp = "功能路径（工程文件)")
    private String iFuncComponent;

    /** 作成者 */
    @Excel(name = "作成者")
    private String iEntryId;

    /** 作成日 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "作成日", width = 30, dateFormat = "yyyy-MM-dd")
    private Date iEntryDate;

    /** 更新者 */
    @Excel(name = "更新者")
    private String iUpdId;

    /** 更新日 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "更新日", width = 30, dateFormat = "yyyy-MM-dd")
    private Date iUpdDate;

    /** 应用路径（工程文件） */
    @Excel(name = "应用路径", readConverterExp = "工=程文件")
    private String iAppComponent;

    /** 模块路径（工程文件） */
    @Excel(name = "模块路径", readConverterExp = "工=程文件")
    private String iModuleComponent;

    /** 功能名称（工程文件） */
    @Excel(name = "功能名称", readConverterExp = "工=程文件")
    private String iFuncName;

    /** 应用名称（工程文件） */
    @Excel(name = "应用名称", readConverterExp = "工=程文件")
    private String iAppName;

    /** 模块名称（工程文件）
     */
    @Excel(name = "模块名称", readConverterExp = "工=程文件")
    private String iModuleName;

    /** 功能面包屑 */
    @Excel(name = "功能面包屑")
    private String iFuncBreadcrumb;

    /** 菜单隐藏 */
    @Excel(name = "菜单隐藏")
    private String iFuncHidden;

    /** 应用面包屑 */
    @Excel(name = "应用面包屑")
    private String iAppBreadcrumb;

    /** 应用菜单隐藏 */
    @Excel(name = "应用菜单隐藏")
    private String iAppHidden;

    /** 模块面包屑 */
    @Excel(name = "模块面包屑")
    private String iModuleBreadcrumb;

    /** 模块隐藏 */
    @Excel(name = "模块隐藏")
    private String iModuleHidden;

    /* 语言类型 */
    private String languageType;

    public void setiFuncId(String iFuncId)
    {
        this.iFuncId = iFuncId;
    }

    public String getiFuncId()
    {
        return iFuncId;
    }
    public void setiFuncNameCh(String iFuncNameCh)
    {
        this.iFuncNameCh = iFuncNameCh;
    }

    public String getiFuncNameCh()
    {
        return iFuncNameCh;
    }
    public void setiFuncNameJp(String iFuncNameJp)
    {
        this.iFuncNameJp = iFuncNameJp;
    }

    public String getiFuncNameJp()
    {
        return iFuncNameJp;
    }
    public void setiFuncNameEn(String iFuncNameEn)
    {
        this.iFuncNameEn = iFuncNameEn;
    }

    public String getiFuncNameEn()
    {
        return iFuncNameEn;
    }
    public void setiFuncPath(String iFuncPath)
    {
        this.iFuncPath = iFuncPath;
    }

    public String getiFuncPath()
    {
        return iFuncPath;
    }
    public void setiFuncSort(String iFuncSort)
    {
        this.iFuncSort = iFuncSort;
    }

    public String getiFuncSort()
    {
        return iFuncSort;
    }
    public void setiEnableFlag(String iEnableFlag)
    {
        this.iEnableFlag = iEnableFlag;
    }

    public String getiEnableFlag()
    {
        return iEnableFlag;
    }
    public void setiAddFlag(String iAddFlag)
    {
        this.iAddFlag = iAddFlag;
    }

    public String getiAddFlag()
    {
        return iAddFlag;
    }
    public void setiUpdateFlag(String iUpdateFlag)
    {
        this.iUpdateFlag = iUpdateFlag;
    }

    public String getiUpdateFlag()
    {
        return iUpdateFlag;
    }
    public void setiDeleteFlag(String iDeleteFlag)
    {
        this.iDeleteFlag = iDeleteFlag;
    }

    public String getiDeleteFlag()
    {
        return iDeleteFlag;
    }
    public void setiExportFlag(String iExportFlag)
    {
        this.iExportFlag = iExportFlag;
    }

    public String getiExportFlag()
    {
        return iExportFlag;
    }
    public void setiImportFlag(String iImportFlag)
    {
        this.iImportFlag = iImportFlag;
    }

    public String getiImportFlag()
    {
        return iImportFlag;
    }
    public void setiSpecialFlag(String iSpecialFlag)
    {
        this.iSpecialFlag = iSpecialFlag;
    }

    public String getiSpecialFlag()
    {
        return iSpecialFlag;
    }
    public void setiAppId(String iAppId)
    {
        this.iAppId = iAppId;
    }

    public String getiAppId()
    {
        return iAppId;
    }
    public void setiAppSort(String iAppSort)
    {
        this.iAppSort = iAppSort;
    }

    public String getiAppSort()
    {
        return iAppSort;
    }
    public void setiAppNameCh(String iAppNameCh)
    {
        this.iAppNameCh = iAppNameCh;
    }

    public String getiAppNameCh()
    {
        return iAppNameCh;
    }
    public void setiAppNameJp(String iAppNameJp)
    {
        this.iAppNameJp = iAppNameJp;
    }

    public String getiAppNameJp()
    {
        return iAppNameJp;
    }
    public void setiAppNameEn(String iAppNameEn)
    {
        this.iAppNameEn = iAppNameEn;
    }

    public String getiAppNameEn()
    {
        return iAppNameEn;
    }
    public void setiAppIcon(String iAppIcon)
    {
        this.iAppIcon = iAppIcon;
    }

    public String getiAppIcon()
    {
        return iAppIcon;
    }
    public void setiAppPath(String iAppPath)
    {
        this.iAppPath = iAppPath;
    }

    public String getiAppPath()
    {
        return iAppPath;
    }
    public void setiModuleId(String iModuleId)
    {
        this.iModuleId = iModuleId;
    }

    public String getiModuleId()
    {
        return iModuleId;
    }
    public void setiModuleSort(String iModuleSort)
    {
        this.iModuleSort = iModuleSort;
    }

    public String getiModuleSort()
    {
        return iModuleSort;
    }
    public void setiModuleNameCh(String iModuleNameCh)
    {
        this.iModuleNameCh = iModuleNameCh;
    }

    public String getiModuleNameCh()
    {
        return iModuleNameCh;
    }
    public void setiModuleNameJp(String iModuleNameJp)
    {
        this.iModuleNameJp = iModuleNameJp;
    }

    public String getiModuleNameJp()
    {
        return iModuleNameJp;
    }
    public void setiModuleNameEn(String iModuleNameEn)
    {
        this.iModuleNameEn = iModuleNameEn;
    }

    public String getiModuleNameEn()
    {
        return iModuleNameEn;
    }
    public void setiModuleIcon(String iModuleIcon)
    {
        this.iModuleIcon = iModuleIcon;
    }

    public String getiModuleIcon()
    {
        return iModuleIcon;
    }
    public void setiModulePath(String iModulePath)
    {
        this.iModulePath = iModulePath;
    }

    public String getiModulePath()
    {
        return iModulePath;
    }
    public void setiFuncComponent(String iFuncComponent)
    {
        this.iFuncComponent = iFuncComponent;
    }

    public String getiFuncComponent()
    {
        return iFuncComponent;
    }
    public void setiEntryId(String iEntryId)
    {
        this.iEntryId = iEntryId;
    }

    public String getiEntryId()
    {
        return iEntryId;
    }
    public void setiEntryDate(Date iEntryDate)
    {
        this.iEntryDate = iEntryDate;
    }

    public Date getiEntryDate()
    {
        return iEntryDate;
    }
    public void setiUpdId(String iUpdId)
    {
        this.iUpdId = iUpdId;
    }

    public String getiUpdId()
    {
        return iUpdId;
    }
    public void setiUpdDate(Date iUpdDate)
    {
        this.iUpdDate = iUpdDate;
    }

    public Date getiUpdDate()
    {
        return iUpdDate;
    }
    public void setiAppComponent(String iAppComponent)
    {
        this.iAppComponent = iAppComponent;
    }

    public String getiAppComponent()
    {
        return iAppComponent;
    }
    public void setiModuleComponent(String iModuleComponent)
    {
        this.iModuleComponent = iModuleComponent;
    }

    public String getiModuleComponent()
    {
        return iModuleComponent;
    }
    public void setiFuncName(String iFuncName)
    {
        this.iFuncName = iFuncName;
    }

    public String getiFuncName()
    {
        return iFuncName;
    }
    public void setiAppName(String iAppName)
    {
        this.iAppName = iAppName;
    }

    public String getiAppName()
    {
        return iAppName;
    }
    public void setiModuleName(String iModuleName)
    {
        this.iModuleName = iModuleName;
    }

    public String getiModuleName()
    {
        return iModuleName;
    }
    public void setiFuncBreadcrumb(String iFuncBreadcrumb)
    {
        this.iFuncBreadcrumb = iFuncBreadcrumb;
    }

    public String getiFuncBreadcrumb()
    {
        return iFuncBreadcrumb;
    }
    public void setiFuncHidden(String iFuncHidden)
    {
        this.iFuncHidden = iFuncHidden;
    }

    public String getiFuncHidden()
    {
        return iFuncHidden;
    }
    public void setiAppBreadcrumb(String iAppBreadcrumb)
    {
        this.iAppBreadcrumb = iAppBreadcrumb;
    }

    public String getiAppBreadcrumb()
    {
        return iAppBreadcrumb;
    }
    public void setiAppHidden(String iAppHidden)
    {
        this.iAppHidden = iAppHidden;
    }

    public String getiAppHidden()
    {
        return iAppHidden;
    }
    public void setiModuleBreadcrumb(String iModuleBreadcrumb)
    {
        this.iModuleBreadcrumb = iModuleBreadcrumb;
    }

    public String getiModuleBreadcrumb()
    {
        return iModuleBreadcrumb;
    }
    public void setiModuleHidden(String iModuleHidden)
    {
        this.iModuleHidden = iModuleHidden;
    }

    public String getiModuleHidden()
    {
        return iModuleHidden;
    }

    public String getLanguageType() {
        return languageType;
    }

    public void setLanguageType(String languageType) {
        this.languageType = languageType;
    }
}
