package com.ruoyi.project.workflow.domain;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.framework.aspectj.lang.annotation.Excel;
import com.ruoyi.framework.web.domain.BaseEntity;

/**
 * フォーム設計对象 w_form_design
 * 
 * @author ruoyi
 * @date 2023-05-19
 */
public class WFormDesign extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** フォームID */
    private Long iFormId;

    /** フォーム名称 */
    @Excel(name = "フォーム名称")
    private String iFormName;

    /** フォーム説明 */
    @Excel(name = "フォーム説明")
    private String iFormDetail;

    /** フォーム版 */
    @Excel(name = "フォーム版")
    private Long iFormVersion;

    /** 前回フォームID */
    @Excel(name = "前回フォームID")
    private Long iPreVerFormId;

    /** 初回フォームID */
    @Excel(name = "初回フォームID")
    private Long iFstVerFormId;

    /** フォームレイアウト */
    @Excel(name = "フォームレイアウト")
    private String iFormLayout;

    /** フォームデータテーブル名 */
    @Excel(name = "フォームデータテーブル名")
    private String iFormDataTblname;

    /** 利用開始日 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "利用開始日", width = 30, dateFormat = "yyyy-MM-dd")
    private Date iUseSYmd;

    /** 利用終了日 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "利用終了日", width = 30, dateFormat = "yyyy-MM-dd")
    private Date iUseEYmd;

    /** 前回終了日 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "前回終了日", width = 30, dateFormat = "yyyy-MM-dd")
    private Date iPreUseEYmd;

    /** 操作フラグ */
    @Excel(name = "操作フラグ")
    private String iOprFlg;

    /** 所轄会社 */
    @Excel(name = "所轄会社")
    private String iCompanyNo;

    /** 採番規則 */
    @Excel(name = "採番規則")
    private String iNumberRules;

    /** フロー設定内容 */
    @Excel(name = "フロー設定内容")
    private String iFlowData;

    /** フロー有無 */
    @Excel(name = "フロー有無")
    private String iFlowFlg;

    /** 多言語有無 */
    @Excel(name = "多言語有無")
    private String iLanguageFlg;

    /** 作成者 */
    @Excel(name = "作成者")
    private String iEntryId;

    /** 作成日 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "作成日", width = 30, dateFormat = "yyyy-MM-dd")
    private Date iEntryDate;

    /** 更新者 */
    @Excel(name = "更新者")
    private String iUpdId;

    /** 更新日 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "更新日", width = 30, dateFormat = "yyyy-MM-dd")
    private Date iUpdDate;

    public void setiFormId(Long iFormId) 
    {
        this.iFormId = iFormId;
    }

    public Long getiFormId() 
    {
        return iFormId;
    }
    public void setiFormName(String iFormName) 
    {
        this.iFormName = iFormName;
    }

    public String getiFormName() 
    {
        return iFormName;
    }
    public void setiFormDetail(String iFormDetail) 
    {
        this.iFormDetail = iFormDetail;
    }

    public String getiFormDetail() 
    {
        return iFormDetail;
    }
    public void setiFormVersion(Long iFormVersion) 
    {
        this.iFormVersion = iFormVersion;
    }

    public Long getiFormVersion() 
    {
        return iFormVersion;
    }
    public void setiPreVerFormId(Long iPreVerFormId) 
    {
        this.iPreVerFormId = iPreVerFormId;
    }

    public Long getiPreVerFormId() 
    {
        return iPreVerFormId;
    }
    public void setiFstVerFormId(Long iFstVerFormId) 
    {
        this.iFstVerFormId = iFstVerFormId;
    }

    public Long getiFstVerFormId() 
    {
        return iFstVerFormId;
    }
    public void setiFormLayout(String iFormLayout) 
    {
        this.iFormLayout = iFormLayout;
    }

    public String getiFormLayout() 
    {
        return iFormLayout;
    }
    public void setiFormDataTblname(String iFormDataTblname) 
    {
        this.iFormDataTblname = iFormDataTblname;
    }

    public String getiFormDataTblname() 
    {
        return iFormDataTblname;
    }
    public void setiUseSYmd(Date iUseSYmd) 
    {
        this.iUseSYmd = iUseSYmd;
    }

    public Date getiUseSYmd() 
    {
        return iUseSYmd;
    }
    public void setiUseEYmd(Date iUseEYmd) 
    {
        this.iUseEYmd = iUseEYmd;
    }

    public Date getiUseEYmd() 
    {
        return iUseEYmd;
    }
    public void setiPreUseEYmd(Date iPreUseEYmd) 
    {
        this.iPreUseEYmd = iPreUseEYmd;
    }

    public Date getiPreUseEYmd() 
    {
        return iPreUseEYmd;
    }
    public void setiOprFlg(String iOprFlg) 
    {
        this.iOprFlg = iOprFlg;
    }

    public String getiOprFlg() 
    {
        return iOprFlg;
    }
    public void setiCompanyNo(String iCompanyNo) 
    {
        this.iCompanyNo = iCompanyNo;
    }

    public String getiCompanyNo() 
    {
        return iCompanyNo;
    }
    public void setiNumberRules(String iNumberRules) 
    {
        this.iNumberRules = iNumberRules;
    }

    public String getiNumberRules() 
    {
        return iNumberRules;
    }
    public void setiFlowData(String iFlowData) 
    {
        this.iFlowData = iFlowData;
    }

    public String getiFlowData() 
    {
        return iFlowData;
    }
    public void setiFlowFlg(String iFlowFlg) 
    {
        this.iFlowFlg = iFlowFlg;
    }

    public String getiFlowFlg() 
    {
        return iFlowFlg;
    }
    public void setiLanguageFlg(String iLanguageFlg) 
    {
        this.iLanguageFlg = iLanguageFlg;
    }

    public String getiLanguageFlg() 
    {
        return iLanguageFlg;
    }
    public void setiEntryId(String iEntryId) 
    {
        this.iEntryId = iEntryId;
    }

    public String getiEntryId() 
    {
        return iEntryId;
    }
    public void setiEntryDate(Date iEntryDate) 
    {
        this.iEntryDate = iEntryDate;
    }

    public Date getiEntryDate() 
    {
        return iEntryDate;
    }
    public void setiUpdId(String iUpdId) 
    {
        this.iUpdId = iUpdId;
    }

    public String getiUpdId() 
    {
        return iUpdId;
    }
    public void setiUpdDate(Date iUpdDate) 
    {
        this.iUpdDate = iUpdDate;
    }

    public Date getiUpdDate() 
    {
        return iUpdDate;
    }
}
