package com.ruoyi.project.workflow.mapper;

import com.ruoyi.project.workflow.domain.db.out.BLanguageMsOut;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

@Mapper
public interface SysPostPartMapper {

    /**
     * 取得所有岗位
     */
    public List<BLanguageMsOut> getAllPost(String postId);

    /**
     * 取得所有角色
     */
    public List<BLanguageMsOut> getAllRole(String roleId);

    /**
     * 取得部门内存在的岗位
     */
    public List<BLanguageMsOut> getPostByDeptId(String deptPost);

    /**
     * 获取岗位所有用户
     */
    public List<String> selectUserIdsByPostId(String postId);

    /**
     * 取得部门内存在的岗位的用户
     */
    public List<String> selectUserByDeptPost(String deptPost);

    /**
     * 根据角色取得用户
     */
    public List<String> selectUserByRoleId(String roleId);

    /**
     * 取得岗位名称
     */
    public String selectPostNameByPostId(String postId);

    /**
     * 取得角色名称
     */
    public String selectRoleNameByRoleId(String roleId);
}
