package com.ruoyi.project.workflow.mapper;

import com.ruoyi.project.system.domain.SysDept;
import com.ruoyi.project.workflow.domain.db.out.BLanguageMsOut;
import com.ruoyi.project.workflow.domain.db.out.TaskUserMailOut;
import com.ruoyi.project.workflow.domain.db.out.UserDeptListOut;
import com.ruoyi.project.workflow.domain.db.out.UserMailOut;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

@Mapper
public interface SysUserDeptMapper {

    /*
    用户一览
     */
    public List<UserDeptListOut> selectUserList(String str);

    /*
    用户公司Id
     */
    public String getCompanyId(String deptId);

    /*
    用户
     */
    public UserDeptListOut getUserById(String userId);

    /*
    邮件
     */
    public UserMailOut getEmailById(String userId);

    /*
    昵称
     */
    public String selectNickNameById(String userId);

    /*
     用户，邮件
    */
    public List<TaskUserMailOut> getEmailByIds(String userIds);

    /*
    获取部门所有用户
     */
    public List<String> selectUserIdByDeptId(String deptId);

    /*
    获取公司名称
    */
    public String selectDeptNameByDeptId(String deptId);

    /*
    获取所有部门
    */
    public List<SysDept> selectAllDept(SysDept sysDept);

    /*
    获取公司名称s
    */
    public List<BLanguageMsOut> selectDeptNamesByDeptIds(String deptIds);

    /*
    获取上级公司
    */
    public List<BLanguageMsOut> selectDeptNamesByParentId(long parentId);

    /*
     获取负责人
    */
    public String selectLeaderByDeptId(String deptId);
}
