package com.ruoyi.project.workflow.mapper;

import com.ruoyi.project.workflow.domain.WFormDesign;
import com.ruoyi.project.workflow.domain.base.SeachBase;
import com.ruoyi.project.workflow.domain.db.WFormDesignEidt;
import com.ruoyi.project.workflow.domain.db.in.WFormDesignYilanIn;
import com.ruoyi.project.workflow.domain.db.out.BWordbookMsOut;
import com.ruoyi.project.workflow.domain.db.out.WFormDesignCopyCreate;
import com.ruoyi.project.workflow.domain.db.out.WFormDesignYilanOut;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

@Mapper
public interface WFormDesignMapper {

    /**
     * 查询wf列表
     */
    public List<WFormDesignYilanOut> selectWFormDesignList(WFormDesignYilanIn wFormDesignYilanIn);

    /**
     * 查询wf列表件数
     */
    public Long selectWFormDesignListCount(WFormDesignYilanIn wFormDesignYilanIn);

    /**
     *查询wf列表（无limit）
     **/
    public List<WFormDesignYilanOut> selectWFormDesignListUnLimt(WFormDesignYilanIn wFormDesignYilanIn);

    /**
     * 删除フォーム設計
     */
    public int deleteWFormDesignByIFormId(Long iFormId);

    /**
     * 还原前版本表单的失效日
     */
    public int updateIUseEYmd(Long preVerFormId);

    /**
     * 更新前版本表单的编辑FLG
     */
    public int updateIOprFlg(Long preVerFormId);

    /*
    表单情报
     */
    public WFormDesignEidt selectWFormDesignById(String iFormId);

    /*
    插入
     */
    public int insertWFormDesign(WFormDesign wFormDesign);

    /*
    存在check
     */
    public int checkFormNameExist(SeachBase bEntity);

    /*
   表单ID采番
    */
    public Long getNextIFormId();

    /*
   申请数据表名存在check
    */
    public int checkTblNameExist(SeachBase bEntity);

    /*
   取得表单状态
    */
    public String getFormStatusByFormId(Long iFormId);

    /*
    取得表单数据（Copy用）
     */
    public WFormDesignCopyCreate getDataForCopyByFormId(Long iFormId);

    /*
     * 修改フォーム設計
     */
    public int updateWFormDesign(WFormDesign wFormDesign);

    /*
     * 前版本表单设计表数据更新
     */
    public int updatePreWFormDesign(WFormDesign wFormDesign);

    /*
     * 表单列数据取得
     */
    public String getLayoutByFormId(Long iFormId);

    /*
    更新表单名
     */
    public int updateFormNameByKey(WFormDesign wFormDesign);

    /*
    更新表单详细
     */
    public int updateFormDetailByKey(WFormDesign wFormDesign);

    /*
    更新表单结构
     */
    public int updateFormLayoutByKey(WFormDesign wFormDesign);

    /*
    更新利用开始日
     */
    public int updateUseSYmdByKey(WFormDesign wFormDesign);

    /*
    更新利用终了日
     */
    public int updateUseEYmdByKey(WFormDesign wFormDesign);

    /*
    更新采番规则
     */
    public int updateNumberRulesByKey(WFormDesign wFormDesign);

    /*
    更新FLOW结构
     */
    public int updateFlowDataByKey(WFormDesign wFormDesign);

    /*
    更新审批要否开关状态
     */
    public int updateFlowFlgByKey(WFormDesign wFormDesign);

    /*
    更新多语言开关状态
     */
    public int updateLanguageFlgByKey(WFormDesign wFormDesign);

    /*
    取得全部表单（或指定表单）
     */
    public List<BWordbookMsOut> selectAllForm(String schField);

}
