package com.ruoyi.project.workflow.mapper;

import com.ruoyi.project.workflow.domain.WGroup;
import com.ruoyi.project.workflow.domain.db.in.WGroupYilanIn;
import com.ruoyi.project.workflow.domain.db.out.BLanguageMsOut;
import com.ruoyi.project.workflow.domain.db.out.WGroupDetailOut;
import com.ruoyi.project.workflow.domain.db.out.WGroupMemberOut;
import com.ruoyi.project.workflow.domain.db.out.WGroupYilanOut;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

@Mapper
public interface WGroupMapper {

    /*
    责任者
     */
    public String selectGroupMasterByKey(Long iGroupId);

    /*
    分组用户
     */
    public List<String> selectGroupUsersByKey(Long iGroupId);

    /*
    分组名称
     */
    public String selectRroupNameByKey(Long iGroupId);

    /**
     * 分组一览
     */
    public List<WGroupYilanOut> selectWGroupList(WGroupYilanIn wGroupYilanIn);

    /**
     * 分组一览件数
     */
    public Long selectWGroupCount(WGroupYilanIn wGroupYilanIn);

    /**
     * 分组一览（无limit）
     */
    public List<WGroupYilanOut> selectWGroupUnLimt(WGroupYilanIn wGroupYilanIn);

    /**
     * 详细
     */
    public WGroupDetailOut selectWGroupDetailById(Long iGroupId);

    /**
     * 成员
     */
    public List<WGroupMemberOut> selectWGroupMemberById(Long iGroupId);

    /**
     * 角色ID采番
     */
    public Long selectNewGroupId();

    /**
     *判断是否已经存在
     */
    public List<String> selectCheckExists(WGroup wGroup);

    /**
     * 新增ロール
     */
    public int insertWGroup(WGroup wGroup);

    /**
     * 修改ロール
     */
    public int updateWGroup(WGroup wGroup);

    /**
     * 删除
     */
    public int deleteByGroupIds(String iGroupIds);

    /**
     * 取得全部角色（或指定角色）
     */
    public List<BLanguageMsOut> selectAllRole(String iGroupIds);
}
