package com.ruoyi.project.workflow.service;

import com.ruoyi.project.workflow.domain.WFlowTask;
import com.ruoyi.project.workflow.domain.db.out.FlowTaskUserOut;
import com.ruoyi.project.workflow.domain.db.out.TaskUserMailOut;
import com.ruoyi.project.workflow.domain.output.FlowTask;
import com.ruoyi.project.workflow.domain.output.NodeConfig;

import java.util.List;
import java.util.Map;

public interface WFlowTaskService {

    /*
    承认者取得
     */
    List<TaskUserMailOut> selectAduitApplyMail(String applyId, Long applyTimes);

    /*
    承认者取得(取消)
     */
    List<TaskUserMailOut> selectCancelApplyMail(String applyId, Long applyTimes);

    /*
   承认者取得(否决)
    */
    List<TaskUserMailOut> selectRejectApplyMail(String applyId, Long applyTimes, String userId);

    /*
    生成TASK
     */
    String generateTasks(String language, String formId, String applyId, Long applyTimes,
                         String flowData, Map<String, Object> params);

    /*
    取得流程详情
     */
    WFlowTask selectFlowTaskDetail(String applyId, Long applyTimes, String nodeId, String nodeSubId);

    /*
   取得Node数
    */
    Long selectCountNodenum(String applyId, Long applyTimes);

    /*
   取得SUBID数
    */
    Long selectCountSubnum(String applyId, Long applyTimes, String nodeId);

    /*
     取得流程审批人
     */
    List<FlowTaskUserOut> selectFlowTaskUser(String iApplyId, Long iSubmitTimes,
                                             String iNodeId, String iNodeSubId);

    /*
    取得审批流程
     */
    Map<String, Object> getFlowTaskByApplyId(String language, String applyId);

    /*
    取得审批中节点
     */
    List<FlowTask> getCurrentNodeById(String iApplyId, Long iSubmitTimes);
}
