package com.ruoyi.project.workflow.service.impl;

import com.ruoyi.project.workflow.common.Definition;
import com.ruoyi.project.workflow.domain.BAttachM;
import com.ruoyi.project.workflow.mapper.BAttachMMapper;
import com.ruoyi.project.workflow.service.BAttachMService;
import com.ruoyi.project.workflow.service.IBLanguageMsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

import java.util.Date;

@Service("bAttachMService")
public class BAttachMServiceImpl implements BAttachMService {
    @Autowired
    private BAttachMMapper bAttachMMapper;
    @Autowired
    private IBLanguageMsService bLanguageMsService;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String insertBAttachMNewOldFileName(String language, String userId,
                                               String oldFileName, String newFileName) {
        //旧文件取得
        BAttachM oldBAttachM = bAttachMMapper.selectBAttachMByIFileName(oldFileName);
        if (oldBAttachM == null) {
            return bLanguageMsService.GetMessage(language, Definition.COMMON_MSG,  Definition.MSG_COMMON_0091);
        }
        try {
            //插入新数据
            BAttachM newBAttachM = new BAttachM();
            //时间
            Date nowDate = new Date();
            newBAttachM.setiFileName(newFileName);
            newBAttachM.setiFileNameOrg(oldBAttachM.getiFileNameOrg());
            newBAttachM.setiFileType(oldBAttachM.getiFileType());
            newBAttachM.setiEntryId(userId);
            newBAttachM.setiEntryDate(nowDate);
            newBAttachM.setiUpdId(userId);
            newBAttachM.setiUpdDate(nowDate);
            bAttachMMapper.insertBAttachM(newBAttachM);
        } catch (Exception e) {
            //回滚事务
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0091);
        }
        return  Definition.RESULT_S;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String insertNewBAttach(String language, String userId, String fileName, String fileNameOrg,
                                   String fileType) {
        //时间
        Date nowDate = new Date();
        try {
            //插入新数据
            BAttachM newBAttachM = new BAttachM();
            newBAttachM.setiFileName(fileName);
            newBAttachM.setiFileNameOrg(fileNameOrg);
            newBAttachM.setiFileType(fileType);
            newBAttachM.setiEntryId(userId);
            newBAttachM.setiEntryDate(nowDate);
            newBAttachM.setiUpdId(userId);
            newBAttachM.setiUpdDate(nowDate);
            bAttachMMapper.insertBAttachM(newBAttachM);
        } catch (Exception e) {
            //回滚事务
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0122);
        }
        return  Definition.RESULT_S;
    }


    /*
     * 主键查询
     */
    @Override
    public BAttachM selectBAttachMByIFileName(String iFileName) {
        return bAttachMMapper.selectBAttachMByIFileName(iFileName);
    }

    /*
     *文件名取得
     */
    @Override
    public BAttachM selectFileName(String iFileName) {
        return bAttachMMapper.selectFileName(iFileName);
    }

}
