package com.ruoyi.project.workflow.service.impl;

import com.ruoyi.project.workflow.common.Definition;
import com.ruoyi.project.workflow.domain.BLanguageMs;
import com.ruoyi.project.workflow.domain.db.out.BLanguageMsOut;
import com.ruoyi.project.workflow.mapper.BLanguageMsMapper;
import com.ruoyi.project.workflow.service.IBLanguageMsService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("iBLanguageMsService")
public class BLanguageMsServiceImpl implements IBLanguageMsService {

    @Autowired
    private BLanguageMsMapper bLanguageMsMapper;

    /*
      取得消息内容
    */
    @Override
    public String GetMessage(String strLanguage,String pageId, String msgId){
        String returnStr = Definition.NO_MESSAGE;
        if (Definition.I_LANGUAGE_EN.equals(strLanguage)
                ||Definition.I_LANGUAGE_CH.equals(strLanguage)
                ||Definition.I_LANGUAGE_JP.equals(strLanguage)) {
            BLanguageMs inData = new BLanguageMs();
            inData.setiFuncId(pageId);
            inData.setiLanguageId(msgId);
            inData.setLanguageType(strLanguage);
            String getMessage = bLanguageMsMapper.selectMessageByKeys(inData);
            if (StringUtils.isNotEmpty(getMessage)){
                returnStr = getMessage;
            }
        }
        return returnStr;
    }

    /**
     * ALL MSG
     */
    @Override
    public List<BLanguageMsOut> selectAllMessage(BLanguageMs bLanguageMs){
        return bLanguageMsMapper.selectAllMessage(bLanguageMs);
    }

    /**
     * 取字典分类名
     */
    @Override
    public List<BLanguageMsOut> selectDictTypeName(String language, String strField, String strEnable) {
        BLanguageMs bLanguageMs = new BLanguageMs();
        bLanguageMs.setLanguageType(language);
        bLanguageMs.getParams().put(Definition.STR_FIELD, strField);
        bLanguageMs.getParams().put(Definition.STR_ENABLE, strEnable);
        return bLanguageMsMapper.selectDictTypeName(bLanguageMs);
    }

    /**
     * 取得全部字典分类（或指定字典分类）
     */
    @Override
    public List<BLanguageMsOut> selectAllDictType(String language, String schField) {
        BLanguageMs bLanguageMs = new BLanguageMs();
        bLanguageMs.setLanguageType(language);
        bLanguageMs.getParams().put(Definition.STR_SCH_FIELD, schField);
        return bLanguageMsMapper.selectAllDictType(bLanguageMs);
    }
}
