package com.ruoyi.project.workflow.service.impl;


import com.ruoyi.project.workflow.common.Definition;
import com.ruoyi.project.workflow.domain.BWordbookMs;
import com.ruoyi.project.workflow.domain.base.OutButtonBase;
import com.ruoyi.project.workflow.domain.db.out.BWordbookMsOut;
import com.ruoyi.project.workflow.mapper.BWordbookMsMapper;
import com.ruoyi.project.workflow.service.IBWordbookMsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("iBWordbookMsService")
public class BWordbookMsServiceImpl implements IBWordbookMsService {

    @Autowired
    private BWordbookMsMapper bWordbookMsMapper;

    /*
    根据字典分类取得字典信息
    */
    @Override
    public List<BWordbookMsOut> selectDataList(String languageType, String wordbookType, String flg) {
        BWordbookMs bWordbookMs = new BWordbookMs();
        bWordbookMs.setLanguageType(languageType);
        bWordbookMs.setiWordbookType(wordbookType);
        bWordbookMs.setiEnableFlag(flg);
        return bWordbookMsMapper.selectDataList(bWordbookMs);
    }

    /*
   每页显示条数
    */
    @Override
    public String selectPerPage(String languageType){
        BWordbookMs bWordbookMs = new BWordbookMs();
        bWordbookMs.setLanguageType(languageType);
        bWordbookMs.setiWordbookType(Definition.WORD_BOOK_TYPE_99_002);
        bWordbookMs.setiWordbookNo(Definition.WORD_BOOK_NO_99_002_0020);
        bWordbookMs.setiEnableFlag(Definition.FLG_Y);
        return bWordbookMsMapper.selectWordbookNameByKeys(bWordbookMs);
    }

    @Override
    public OutButtonBase selectButtonInfo(String languageType) {
        BWordbookMs bWordbookMs = new BWordbookMs();
        bWordbookMs.setLanguageType(languageType);
        bWordbookMs.setiWordbookType(Definition.WORD_BOOK_TYPE_99_004);
        bWordbookMs.setiEnableFlag(Definition.FLG_Y);

        OutButtonBase outButtonBase = new OutButtonBase();
        //新增
        bWordbookMs.setiWordbookNo(Definition.WORD_BOOK_NO_ADD);
        outButtonBase.setI_btn_add(bWordbookMsMapper.selectWordbookNameByKeys(bWordbookMs));
        //查询
        bWordbookMs.setiWordbookNo(Definition.WORD_BOOK_NO_SEARCH);
        outButtonBase.setI_btn_search(bWordbookMsMapper.selectWordbookNameByKeys(bWordbookMs));
        //删除
        bWordbookMs.setiWordbookNo(Definition.WORD_BOOK_NO_DELETE);
        outButtonBase.setI_btn_delete(bWordbookMsMapper.selectWordbookNameByKeys(bWordbookMs));
        //导入
        bWordbookMs.setiWordbookNo(Definition.WORD_BOOK_NO_IMPORT);
        outButtonBase.setI_btn_import(bWordbookMsMapper.selectWordbookNameByKeys(bWordbookMs));
        //导出
        bWordbookMs.setiWordbookNo(Definition.WORD_BOOK_NO_EXPORT);
        outButtonBase.setI_btn_export(bWordbookMsMapper.selectWordbookNameByKeys(bWordbookMs));

        return outButtonBase;
    }

    @Override
    public List<BWordbookMsOut> selectAllDictList(BWordbookMs bWordbookMs) {
        return bWordbookMsMapper.selectAllDictList(bWordbookMs);
    }

    @Override
    public String selectWordbookNameByKeys(String languageType, String iWordbookType,
                                            String iWordbookNo, String enableFlag) {
        BWordbookMs bWordbookMs = new BWordbookMs();
        bWordbookMs.setLanguageType(languageType);
        bWordbookMs.setiWordbookType(iWordbookType);
        bWordbookMs.setiWordbookNo(iWordbookNo);
        bWordbookMs.setiEnableFlag(enableFlag);
        return bWordbookMsMapper.selectWordbookNameByKeys(bWordbookMs);
    }

    @Override
    public List<BWordbookMsOut> selectWorkBookInfoByType(String languageType, String iWordbookType,
                                                         String iWordbookNo, String enableFlag) {
        BWordbookMs bWordbookMs = new BWordbookMs();
        bWordbookMs.setLanguageType(languageType);
        bWordbookMs.setiWordbookType(iWordbookType);
        bWordbookMs.setiWordbookNo(iWordbookNo);
        bWordbookMs.setiEnableFlag(enableFlag);
        return bWordbookMsMapper.selectWorkBookInfoByType(bWordbookMs);
    }

}
