package com.ruoyi.project.workflow.service.impl;

import com.ruoyi.project.workflow.domain.db.out.BLanguageMsOut;
import com.ruoyi.project.workflow.mapper.SysPostPartMapper;
import com.ruoyi.project.workflow.service.SysPostPartService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("sysPostPartService")
public class SysPostPartServiceImpl implements SysPostPartService {

    @Autowired
    private SysPostPartMapper sysPostPartMapper;

    /**
     * 取得所有岗位
     */
    @Override
    public List<BLanguageMsOut> getAllPost(String postId) {
        return sysPostPartMapper.getAllPost(postId);
    }

    /**
     * 取得所有角色
     */
    @Override
    public List<BLanguageMsOut> getAllRole(String roleId) {
        return sysPostPartMapper.getAllRole(roleId);
    }

    /**
     * 取得部门内存在的岗位
     */
    @Override
    public List<BLanguageMsOut> getPostByDeptId(String deptPost) {
        return sysPostPartMapper.getPostByDeptId(deptPost);
    }

    /**
     * 获取岗位所有用户
     */
    @Override
    public List<String> selectUserIdsByPostId(String postId) {
        return sysPostPartMapper.selectUserIdsByPostId(postId);
    }

    /**
     * 取得部门内存在的岗位的用户
     */
    @Override
    public List<String> selectUserByDeptPost(String deptPost) {
        return sysPostPartMapper.selectUserByDeptPost(deptPost);
    }

    /**
     * 根据角色取得用户
     */
    @Override
    public List<String> selectUserByRoleId(String roleId) {
        return sysPostPartMapper.selectUserByRoleId(roleId);
    }

    /**
     * 取得岗位名称
     */
    @Override
    public String selectPostNameByPostId(String postId) {
        return sysPostPartMapper.selectPostNameByPostId(postId);
    }

    /**
     * 取得角色名称
     */
    public String selectRoleNameByRoleId(String roleId) {
        return sysPostPartMapper.selectRoleNameByRoleId(roleId);
    }
}
