package com.ruoyi.project.workflow.service.impl;

import com.ruoyi.project.workflow.common.ClsBase;
import com.ruoyi.project.workflow.common.Definition;
import com.ruoyi.project.workflow.domain.WApplication;
import com.ruoyi.project.workflow.domain.WFormDesign;
import com.ruoyi.project.workflow.domain.db.out.ApplyInfoUseForMailOut;
import com.ruoyi.project.workflow.domain.db.out.FormInfoOut;
import com.ruoyi.project.workflow.mapper.WApplicationMapper;
import com.ruoyi.project.workflow.service.WApplicationService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@Service("wApplicationService")
public class WApplicationServiceImpl implements WApplicationService {

    @Autowired
    private WApplicationMapper wApplicationMapper;

    /*
    申请ID采番
     */
    @Override
    public String getApplyId(String striNumberRules) {
        String applyId;
        if (StringUtils.isEmpty(striNumberRules)) {
            applyId = Definition.FIVE_ZERO + ClsBase.getNowDate(Definition.DATE_YYMM);
        } else {
            applyId = StringUtils.left((striNumberRules + Definition.FIVE_ZERO), 5) +
                    ClsBase.getNowDate(Definition.DATE_YYMM);
        }
        List<String> getList =  wApplicationMapper.selectApplyId(applyId);
        if (getList == null || getList.size() == 0) {
            return (applyId + Definition.NEW_APPLY_ID);
        } else {
            Long num = Long.valueOf(StringUtils.right(ClsBase.getTrimData(getList.get(0)), 7));
            num = num + 1;
            return (applyId + String.format(Definition.STR_FORMAT, num));
        }
    }

    /*
    取得申請管理用于邮件发送
     */
    @Override
    public ApplyInfoUseForMailOut selectApplyInfoUseForMail(String language, String applyId, Long submitTimes) {
        WApplication wApplication = new WApplication();
        wApplication.setLanguageType(language);
        wApplication.setiApplyId(applyId);
        wApplication.setiSubmitTimes(submitTimes);
        return wApplicationMapper.selectApplyInfoUseForMail(wApplication);
    }

    /*
    取得申請管理
     */
    @Override
    public WApplication selectApplyInfoByApplyIds(String applyId, Long submitTimes) {
        WApplication wApplication = new WApplication();
        wApplication.setiApplyId(applyId);
        wApplication.setiSubmitTimes(submitTimes);
        return wApplicationMapper.selectApplyInfoByApplyIds(wApplication);
    }

    /*
    根据申请编号取得最新版本（最大提交回数）
     */
    @Override
    public Long selectApplyMaxTimes(String applyId) {
        return wApplicationMapper.selectApplyMaxTimes(applyId);
    }


    /*
   取得表单结构
    */
    @Override
    public String selectFormLayoutByApplyId(String applyId, Long submitTimes, String strkb) {
        WApplication wApplication = new WApplication();
        wApplication.setiApplyId(applyId);
        wApplication.setiSubmitTimes(submitTimes);
        WFormDesign  wFormDesign = wApplicationMapper.selectFormLayoutByApplyId(wApplication);
        if (wFormDesign != null) {
            if (StringUtils.isEmpty(strkb)) {
                return wFormDesign.getiFormLayout();
            } else if (Definition.TBL_NAME.equals(strkb)) {
                return wFormDesign.getiFormDataTblname();
            } else if (Definition.STR_ENDYMD.equals(strkb)) {
                SimpleDateFormat fm = new SimpleDateFormat(Definition.DATE_TODAY);
                return fm.format(wFormDesign.getiUseEYmd());
            }
        }
        return Definition.NULL_STR_1;
    }

    /*
   申请ID关联情报取得
    */
    @Override
    public FormInfoOut selectFormInfoByApplyId(String applyId, Long submitTimes) {
        WApplication wApplication = new WApplication();
        wApplication.setiApplyId(applyId);
        wApplication.setiSubmitTimes(submitTimes);
        return wApplicationMapper.selectFormInfoByApplyId(wApplication);
    }
}
