package com.ruoyi.project.workflow.service.impl;

import com.ruoyi.project.workflow.common.ClsBase;
import com.ruoyi.project.workflow.common.Definition;
import com.ruoyi.project.workflow.domain.WApplication;
import com.ruoyi.project.workflow.domain.WReferenceUser;
import com.ruoyi.project.workflow.domain.db.in.WFormDataInsert;
import com.ruoyi.project.workflow.domain.db.in.WFormDesignNewAppLyIn;
import com.ruoyi.project.workflow.domain.db.out.ApplyRulesOut;
import com.ruoyi.project.workflow.domain.db.out.WFormDesignNewApplyOut;
import com.ruoyi.project.workflow.mapper.WApplicationMapper;
import com.ruoyi.project.workflow.mapper.WFormDataMapper;
import com.ruoyi.project.workflow.mapper.WFormDesignNewApplyMapper;
import com.ruoyi.project.workflow.mapper.WReferenceUserMapper;
import com.ruoyi.project.workflow.service.IBLanguageMsService;
import com.ruoyi.project.workflow.service.WFormDesignNewApplyService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

import java.util.Date;
import java.util.List;

@Service("wFormDesignNewAppLyService")
public class WFormDesignNewApplyServiceImpl implements WFormDesignNewApplyService {

    @Autowired
    private WFormDesignNewApplyMapper wFormDesignNewAppLyMapper;
    @Autowired
    private WFormDataMapper wFormDataMapper;
    @Autowired
    private WApplicationMapper wApplicationMapper;
    @Autowired
    private WReferenceUserMapper wReferenceUserMapper;
    @Autowired
    private IBLanguageMsService bLanguageMsService;

    /**
     * 新增申请列表
     */
    @Override
    public List<WFormDesignNewApplyOut> selectNewApplyList(WFormDesignNewAppLyIn wFormDesignNewAppLyIn){
        return wFormDesignNewAppLyMapper.selectNewApplyList(wFormDesignNewAppLyIn);
    }

    /**
     * 新增申请件数
     */
    @Override
    public Long selectNewApplyCount(WFormDesignNewAppLyIn wFormDesignNewAppLyIn) {
        return wFormDesignNewAppLyMapper.selectNewApplyCount(wFormDesignNewAppLyIn);
    }

    /**
     *新增申请列表（无limit）
     **/
    @Override
    public List<WFormDesignNewApplyOut> selectNewApplyUnLimt(WFormDesignNewAppLyIn wFormDesignNewAppLyIn) {
        return wFormDesignNewAppLyMapper.selectNewApplyUnLimt(wFormDesignNewAppLyIn);
    }

    /**
     *采番规则取得
     **/
    @Override
    public ApplyRulesOut selectNumberRules(String iFormId) {
        return wFormDesignNewAppLyMapper.selectNumberRules(Long.valueOf(iFormId));
    }

    /**
     *保存数据
     **/
    @Override
    @Transactional(rollbackFor = Exception.class)
    public String saveApplyData(String language, String striFormId, String striApplyId, String striPreApplId,
                         String striReferenceUser, String strCols, String strVals, String strTableName){
        //时间
        Date nowDate = new Date();
        //用户
        String userId = ClsBase.getCurrentUser();
        try {
            //保存申请数据
            WFormDataInsert wFormDataInsert = new WFormDataInsert();
            wFormDataInsert.setStrCols(strCols);
            wFormDataInsert.setStrTblName(strTableName);
            wFormDataInsert.setStrVals(strVals);
            wFormDataMapper.insertWFormData(wFormDataInsert);
            //追加申请管理
            WApplication wApplication = new WApplication();
            wApplication.setiApplyId(striApplyId);
            wApplication.setiSubmitTimes(Definition.FST_VERSION);
            wApplication.setiFormId(Long.valueOf(striFormId));
            wApplication.setiApplUser(userId);
            wApplication.setiPreApplId(striPreApplId);
            wApplication.setiStatus(Definition.FLG_ZERO);
            wApplication.setiSubmitDate(null);
            wApplication.setiEntryId(userId);
            wApplication.setiEntryDate(nowDate);
            wApplication.setiUpdId(userId);
            wApplication.setiUpdDate(nowDate);
            wApplicationMapper.insertWApplication(wApplication);
            //cc
            if (StringUtils.isNotEmpty(striReferenceUser)) {
                for (String user : striReferenceUser.split(Definition.ROLE_DELIMETER)) {
                    WReferenceUser wReferenceUser = new WReferenceUser();
                    wReferenceUser.setiApplyId(striApplyId);
                    wReferenceUser.setiUserId(user);
                    wReferenceUser.setiEntryId(userId);
                    wReferenceUser.setiEntryDate(nowDate);
                    wReferenceUser.setiUpdId(userId);
                    wReferenceUser.setiUpdDate(nowDate);
                    wReferenceUserMapper.insertWReferenceUser(wReferenceUser);
                }
            }
            return Definition.RESULT_S;
        } catch (Exception e) {
            //回滚事务
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return bLanguageMsService.GetMessage(language, Definition.COMMON_MSG, Definition.MSG_COMMON_0091);
        }
    }
}
